! calcirf.f90: Program for "Implications of Government Transfers for Aggregate Labor Market Fluctuations"
! by Youngsoo Jang, Takeki Sunakawa and Minchul Yum

program calcirf


    use mod_calcss
    use mod_inner
	use mod_outer
    use mod_parameters


	implicit none


    real(8) agrid(na), mgrid(nm), xgrid(nx), zgrid(nz), pxij(nx,nx), pzij(nz,nz), xss(nx), ALOW
    real(8) bgrid(nb), pbij(nb,nb)
    integer idmat(ne,2), error
    integer ia, ik, im, ib, ix, jx, ie, iz, iterout, iteroutvec(100), i, foreind, i_irind, i_irt, i1
    real(8) w, r, Lss, Kss, Yss, TY, TrY, Trss, khigh, kgrid(nk), mumat(nk,ne), & 
    ndist(nk,ne), Ks, Ls, EPratio, muk(nk), TrInc5(5), TrW5(5), EmpW5(5), stdlogwage, stdlogearn, rhoxest

	real(8) Vmat(na,nm,ne,nz), Wmat(na,nm,ne,nz), Nmat(na,nm,ne,nz)
    real(8) apmat(na,nm,ne,nz), awpmat(na,nm,ne,nz), anpmat(na,nm,ne,nz), lmat(na,nm,ne,nz)

    real(8), allocatable :: kappakp(:,:), kappaw(:,:), kappar(:,:), kappal(:,:)
	integer time, isim, ishk, irfN1
	real(8) aggsim(irfTT,10), disaggsim(irfTT,nx,6), zvec(irfTT)
    real(8) xghz(nghz), wghz(nghz)

	real(8) muz(nz), shockprobdem, shockprob, x(2), conprob(2), shockrand(2)
	integer errcode, brng, seed
    type(vsl_stream_state) :: stream
	integer, parameter :: method = VSL_RNG_METHOD_UNIFORM_STD

	integer, allocatable :: izvec(:,:,:)
	real(8), allocatable :: simk(:,:,:), simw(:,:,:), simr(:,:,:), simy(:,:,:), simc(:,:,:), siminv(:,:,:), &
	siml(:,:,:), simh(:,:,:), simz(:,:,:), simtrans(:,:,:), simyh(:,:,:), simxc(:,:,:,:), simxh(:,:,:,:), &
	simxclow(:,:,:), simxcmid(:,:,:), simxchigh(:,:,:), simxhlow(:,:,:), simxhmid(:,:,:), simxhhigh(:,:,:)
	real(8), allocatable :: simkdiff(:,:), simwdiff(:,:), simrdiff(:,:), simydiff(:,:), simcdiff(:,:), siminvdiff(:,:), &
	simldiff(:,:), simhdiff(:,:), simzdiff(:,:), simtransdiff(:,:), simyhdiff(:,:), simxcdiff(:,:,:), simxhdiff(:,:,:), &
	simxclowdiff(:,:), simxcmiddiff(:,:), simxchighdiff(:,:), simxhlowdiff(:,:), simxhmiddiff(:,:), simxhhighdiff(:,:), &
	simxclowdiffp(:,:), simxcmiddiffp(:,:), simxchighdiffp(:,:), simxhlowdiffp(:,:), simxhmiddiffp(:,:), simxhhighdiffp(:,:)
	real(8) simk1(irfTT), simw1(irfTT), simr1(irfTT), simy1(irfTT), simc1(irfTT), siminv1(irfTT), &
	siml1(irfTT), simh1(irfTT), simz1(irfTT), simtrans1(irfTT), simyh1(irfTT), simxc1(irfTT,nx), simxh1(irfTT,nx), &
	simxclow1(irfTT), simxcmid1(irfTT), simxchigh1(irfTT), simxhlow1(irfTT), simxhmid1(irfTT), simxhhigh1(irfTT), &
	simxclowp1(irfTT), simxcmidp1(irfTT), simxchighp1(irfTT), simxhlowp1(irfTT), simxhmidp1(irfTT), simxhhighp1(irfTT)

    ! for dgetrf, dgetri
    integer, parameter :: ra = na-2
    integer, parameter :: rm = nm-2
    integer INFO
    integer IPIVa(ra), IPIVm(rm)
    real(8) invTa(ra,ra), invTm(rm,rm), WORKa(ra), WORKm(rm)

    integer cto1, cto2, cro
    real(8) eptimeo
	! vsl
    integer maxsimind !errcode, brng, seed, maxsimind
	real(8), allocatable :: murand(:), xrand(:)


    call system_clock(cto1, cro)

    ! index for individual exogenous state
	do ib = 1,nb

		do ix = 1,nx

			ie = (ib-1)*nx + ix
			idmat(ie,1) = ib
			idmat(ie,2) = ix

		end do

	end do

	maxsimind = nint(0.5d0*NS) !nint((maxval(xss)*1.1d0)*NS)
	! for values of brng parameter, see https://software.intel.com/en-us/mkl-developer-reference-fortran-brng-parameter-definition#TBL10-2
	brng = vsl_brng_sfmt19937 ! use Mersenne Twister
	seed = 1234

	errcode = vslnewstream(stream,brng,seed)
	allocate(murand(NS),xrand(nx*maxsimind))
	errcode = vdrnguniform(method,stream,NS,murand,0.0d0,1.0d0)
	errcode = vdrnguniform(method,stream,nx*maxsimind,xrand,0.0d0,1.0d0)

    if (ssini0==1) then
        call readss(idmat,ALPHA,BETA,agrid,kgrid,bgrid,xgrid,pbij,pxij,xss,mumat,ndist,muk,Kss,Lss,Yss,ALOW)
    else
        write(*,*) "calculating the steady state..."
		call calcss(idmat,murand,xrand,agrid,kgrid,bgrid,xgrid,pbij,pxij,xss,ALOW, &
			w,r,Lss,Kss,Yss,TY,TrY,Trss,mumat,ndist,Ks,Ls,EPratio,TrInc5,TrW5,EmpW5,error, &
			ALPHA,DELTA,HBAR,phi,B0,BETA,RHOX,SDINOVX,kappa1,kappa2,Trscale,Transprog1,Transprog2,T0, &
			tol,tolss,toldist,maxiter,dampss0,congrid,deggrida,deggridk,1,diagnum,logdiff,tauflag,calcma,linflag,howflag,hsvflag,mx)
    end if
    write(*,"('  ALOW =', F10.5)") ALOW


    ! set up the grid points
    mgrid = linspace((1.0d0-mpct)*Kss,(1.0d0+mpct)*Kss,nm)

    ! grids for TFP
    call qnwnorm(nghz,0.0d0,SDINOVZ,xghz,wghz)
    if (conzflag==2) then
        zgrid = linspace(-mz*SDINOVZ/sqrt(1.0d0-RHOZ**2),mz*SDINOVZ/sqrt(1.0d0-RHOZ**2),nz)
    else
        if (tauflagagg==1) then
            call tauchen(nz,0.0d0,RHOZ,SDINOVZ,mz,zgrid,pzij)
        else
            call rouwenhorst(RHOZ,SDINOVZ,nz,zgrid,pzij)
        end if
    end if

    zgrid = exp(zgrid)

    ! setup splines
    invTa = spbas(ra,agrid)
    invTm = spbas(rm,mgrid)
    ! take the inverse of the basis function matrix
    invTa = inv(invTa)
    invTm = inv(invTm)

    ! load the equilibrium forecasting rules
    if (conzflag==1) then
        allocate(kappakp(2,nz),kappaw(2,nz),kappar(2,nz),kappal(2,nz))
    else
        allocate(kappakp(3,1),kappaw(3,1),kappar(3,1),kappal(3,1))
    end if
    call readwritekappa(kappakp,kappaw,kappar,kappal,ckappakp,ckappaw,ckappar,ckappal,conzflag,1)

    ! compute the value function
    if (vmatini0==0) then
		call inner(kappakp,kappaw,kappar,agrid,mgrid,invTa,invTm,zgrid,pzij,bgrid,xgrid,pbij,pxij,idmat,Yss, &
			Vmat,apmat,awpmat,anpmat,lmat,xghz,wghz, &
			ALPHA,DELTA,HBAR,ALOW,B0,BETA,RHOZ,kappa1,kappa2,Trscale,Transprog1,Transprog2,T0, &
			tol,maxiter,diagnum,logdiff,0,iterout,fcsteqn,linflag,howflag,hsvflag,conzflag)
        call readwriteVmat(Vmat,0) ! write
    else
        call readwriteVmat(Vmat,1)
    end if


	! generate random numbers for IRF
	! initialize ergodic distribution
	call markovss(pzij,nz,1d-20,muz)

	shockprobdem = zgrid(1) 
	do iz = 1,nz
	    shockprobdem = shockprobdem - muz(iz)*zgrid(iz)
	end do

	shockprob = shocksize/shockprobdem
	irfN1 = floor(shockprob*irfN)
	print *, shockprob, irfN, irfN1

	allocate(izvec(irfTT,irfN1,2),simk(irfTT,irfN1,2),simw(irfTT,irfN1,2),simr(irfTT,irfN1,2),simy(irfTT,irfN1,2),simc(irfTT,irfN1,2),siminv(irfTT,irfN1,2))
	allocate(siml(irfTT,irfN1,2),simh(irfTT,irfN1,2),simz(irfTT,irfN1,2),simtrans(irfTT,irfN1,2),simyh(irfTT,irfN1,2),simxc(irfTT,nx,irfN1,2),simxh(irfTT,nx,irfN1,2))
	allocate(simxclow(irfTT,irfN1,2),simxcmid(irfTT,irfN1,2),simxchigh(irfTT,irfN1,2),simxhlow(irfTT,irfN1,2),simxhmid(irfTT,irfN1,2),simxhhigh(irfTT,irfN1,2))
	allocate(simkdiff(irfTT,irfN1),simwdiff(irfTT,irfN1),simrdiff(irfTT,irfN1),simydiff(irfTT,irfN1))
	allocate(simcdiff(irfTT,irfN1),siminvdiff(irfTT,irfN1),simldiff(irfTT,irfN1),simhdiff(irfTT,irfN1))
	allocate(simzdiff(irfTT,irfN1),simtransdiff(irfTT,irfN1),simyhdiff(irfTT,irfN1),simxcdiff(irfTT,nx,irfN1),simxhdiff(irfTT,nx,irfN1))
	allocate(simxclowdiff(irfTT,irfN1),simxcmiddiff(irfTT,irfN1),simxchighdiff(irfTT,irfN1),simxhlowdiff(irfTT,irfN1),simxhmiddiff(irfTT,irfN1),simxhhighdiff(irfTT,irfN1))
	allocate(simxclowdiffp(irfTT,irfN1),simxcmiddiffp(irfTT,irfN1),simxchighdiffp(irfTT,irfN1),simxhlowdiffp(irfTT,irfN1),simxhmiddiffp(irfTT,irfN1),simxhhighdiffp(irfTT,irfN1))

    brng = vsl_brng_sfmt19937 ! use Mersenne Twister
    seed = 1234
    errcode = vslnewstream(stream,brng,seed)

	do isim = 1,irfN1

		izvec(1,isim,1) = 4
		izvec(1,isim,2) = 4

	    do time = 2,irfTT

	        if (time<irfdrop+2) then

	            ! both transit as normal
				errcode = vdrnguniform(method,stream,2,x,0.0d0,1.0d0)
	            iz = izvec(time-1,isim,1)
				conprob = randsample(x,pzij(iz,:))
		        izvec(time,isim,1) = conprob(1)
				izvec(time,isim,2) = conprob(1)

	        elseif (time==irfdrop+2) then

				! in this case, transit normally only for version 2, not version 1

				! version 2 is shocked, goes to shockasnumIRF position
				izvec(time,isim,2) = shockgrid;

				! version 1 transits normally
				errcode = vdrnguniform(method,stream,2,x,0.0d0,1.0d0)
				iz = izvec(time-1,isim,1);
				conprob = randsample(x,pzij(iz,:))
				izvec(time,isim,1) = conprob(1)

	        elseif (time>irfdrop+2) then

	            ! both transit as normal, but separately
				! NOTE: use the same random number
				errcode = vdrnguniform(method,stream,2,x,0.0d0,1.0d0)

	            ! version 1 transits normally
	            iz = izvec(time-1,isim,1)
				conprob = randsample(x,pzij(iz,:))
				izvec(time,isim,1) = conprob(1)

	            ! version 2 transits normally
	            iz = izvec(time-1,isim,2)
				conprob = randsample(x,pzij(iz,:))
				izvec(time,isim,2) = conprob(1)

			end if

		end do

	end do

	do isim = 1,irfN1

		do ishk = 1,2

			print *, isim, ishk

			call outer(Vmat,kappakp,kappaw,kappar,agrid,mgrid,kgrid,invTa,invTm,zgrid,pzij,bgrid,xgrid,pbij,pxij,idmat,izvec(:,isim,ishk),irfTT,Yss, &
				aggsim,disaggsim,mumat,zvec,xghz,wghz, &
				ALPHA,DELTA,HBAR,ALOW,B0,BETA,RHOZ,kappa1,kappa2,Trscale,Transprog1,Transprog2,T0, &
				tol,tolmkt,outermkt,1,bsctr,bspct0,maxcountmkt,calcma,bsfixr,diagnumout,fcsteqn,linflag,hsvflag,conzflag)

			simk(:,isim,ishk)     = aggsim(:,1)
			simw(:,isim,ishk)     = aggsim(:,2)
			simr(:,isim,ishk)     = aggsim(:,3)
			simy(:,isim,ishk)     = aggsim(:,4)
			simc(:,isim,ishk)     = aggsim(:,5)
			siminv(:,isim,ishk)   = aggsim(:,6)
			siml(:,isim,ishk)     = aggsim(:,7)
			simh(:,isim,ishk)     = aggsim(:,8)
			simz(:,isim,ishk)     = aggsim(:,9)
			simtrans(:,isim,ishk) = aggsim(:,10)

			simxc(:,:,isim,ishk)  = disaggsim(:,:,1)
			simxh(:,:,isim,ishk)  = disaggsim(:,:,2)

			simxclow(:,isim,ishk)  = (xss(1)*simxc(:,1,isim,ishk) + xss(2)*simxc(:,2,isim,ishk) + xss(3)*simxc(:,3,isim,ishk) + xss(4)*simxc(:,4,isim,ishk))/sum(xss(1:4))
			simxcmid(:,isim,ishk)  = (xss(5)*simxc(:,5,isim,ishk) + xss(6)*simxc(:,6,isim,ishk))/sum(xss(5:6))
			simxchigh(:,isim,ishk) = (xss(7)*simxc(:,7,isim,ishk) + xss(8)*simxc(:,8,isim,ishk) + xss(9)*simxc(:,9,isim,ishk) + xss(10)*simxc(:,10,isim,ishk))/sum(xss(7:10))
			simxhlow(:,isim,ishk)  = (xss(1)*simxh(:,1,isim,ishk) + xss(2)*simxh(:,2,isim,ishk) + xss(3)*simxh(:,3,isim,ishk) + xss(4)*simxh(:,4,isim,ishk))/sum(xss(1:4))
			simxhmid(:,isim,ishk)  = (xss(5)*simxh(:,5,isim,ishk) + xss(6)*simxh(:,6,isim,ishk))/sum(xss(5:6))
			simxhhigh(:,isim,ishk) = (xss(7)*simxh(:,7,isim,ishk) + xss(8)*simxh(:,8,isim,ishk) + xss(9)*simxh(:,9,isim,ishk) + xss(10)*simxh(:,10,isim,ishk))/sum(xss(7:10))

		end do

	end do

	do isim = 1,irfN1

		do time = 1,irfTT

			simkdiff(time,isim) = 100*log(simk(time,isim,2)/simk(time,isim,1))
			simwdiff(time,isim) = 100*log(simw(time,isim,2)/simw(time,isim,1))
			! NOTE: % point deviation from s.s.
			simrdiff(time,isim) = 100*(simr(time,isim,2)-simr(time,isim,1))
			simydiff(time,isim) = 100*log(simy(time,isim,2)/simy(time,isim,1))
			simcdiff(time,isim) = 100*log(simc(time,isim,2)/simc(time,isim,1))
			siminvdiff(time,isim) = 100*log(siminv(time,isim,2)/siminv(time,isim,1))
			simldiff(time,isim) = 100*log(siml(time,isim,2)/siml(time,isim,1))
			simhdiff(time,isim) = 100*log(simh(time,isim,2)/simh(time,isim,1))
			simzdiff(time,isim) = 100*(zgrid(izvec(time,isim,2))-zgrid(izvec(time,isim,1)))
			simtransdiff(time,isim) = 100*log(simtrans(time,isim,2)/simtrans(time,isim,1))
			! NOTE: it can be composed by using simy and simh (to be checked)
			simyhdiff(time,isim) = 100*(log(simy(time,isim,2)/simh(time,isim,2))-log(simy(time,isim,1)/simh(time,isim,1)))

			do ix = 1,nx

				simxcdiff(time,ix,isim) = 100*log(simxc(time,ix,isim,2)/simxc(time,ix,isim,1))
				simxhdiff(time,ix,isim) = 100*log(simxh(time,ix,isim,2)/simxh(time,ix,isim,1))

			end do

			simxclowdiff(time,isim)   = 100*log(simxclow(time,isim,2)/simxclow(time,isim,1))
			simxcmiddiff(time,isim)   = 100*log(simxcmid(time,isim,2)/simxcmid(time,isim,1))
			simxchighdiff(time,isim)  = 100*log(simxchigh(time,isim,2)/simxchigh(time,isim,1))
			simxhlowdiff(time,isim)   = 100*log(simxhlow(time,isim,2)/simxhlow(time,isim,1))
			simxhmiddiff(time,isim)   = 100*log(simxhmid(time,isim,2)/simxhmid(time,isim,1))
			simxhhighdiff(time,isim)  = 100*log(simxhhigh(time,isim,2)/simxhhigh(time,isim,1))
			simxclowdiffp(time,isim)  = 100*(simxclow(time,isim,2)-simxclow(time,isim,1))
			simxcmiddiffp(time,isim)  = 100*(simxcmid(time,isim,2)-simxcmid(time,isim,1))
			simxchighdiffp(time,isim) = 100*(simxchigh(time,isim,2)-simxchigh(time,isim,1))
			simxhlowdiffp(time,isim)  = 100*(simxhlow(time,isim,2)-simxhlow(time,isim,1))
			simxhmiddiffp(time,isim)  = 100*(simxhmid(time,isim,2)-simxhmid(time,isim,1))
			simxhhighdiffp(time,isim) = 100*(simxhhigh(time,isim,2)-simxhhigh(time,isim,1))

		end do

	end do

	simk1 = shockprob*sum(simkdiff,2)/irfN1
	simw1 = shockprob*sum(simwdiff,2)/irfN1
	simr1 = shockprob*sum(simrdiff,2)/irfN1
	simy1 = shockprob*sum(simydiff,2)/irfN1
	simc1 = shockprob*sum(simcdiff,2)/irfN1
	siminv1 = shockprob*sum(siminvdiff,2)/irfN1
	siml1 = shockprob*sum(simldiff,2)/irfN1
	simh1 = shockprob*sum(simhdiff,2)/irfN1
	simz1 = shockprob*sum(simzdiff,2)/irfN1
	simtrans1 = shockprob*sum(simtransdiff,2)/irfN1
	simyh1 = shockprob*sum(simyhdiff,2)/irfN1

	do ix = 1,nx
		simxc1(:,ix) = shockprob*sum(reshape(simxcdiff(:,ix,:),(/irfTT,irfN1/)),2)/irfN1
		simxh1(:,ix) = shockprob*sum(reshape(simxhdiff(:,ix,:),(/irfTT,irfN1/)),2)/irfN1
	end do

	simxclow1 = shockprob*sum(simxclowdiff,2)/irfN1
	simxcmid1 = shockprob*sum(simxcmiddiff,2)/irfN1
	simxchigh1 = shockprob*sum(simxchighdiff,2)/irfN1
	simxhlow1 = shockprob*sum(simxhlowdiff,2)/irfN1
	simxhmid1 = shockprob*sum(simxhmiddiff,2)/irfN1
	simxhhigh1 = shockprob*sum(simxhhighdiff,2)/irfN1

	simxclowp1 = shockprob*sum(simxclowdiffp,2)/irfN1
	simxcmidp1 = shockprob*sum(simxcmiddiffp,2)/irfN1
	simxchighp1 = shockprob*sum(simxchighdiffp,2)/irfN1
	simxhlowp1 = shockprob*sum(simxhlowdiffp,2)/irfN1
	simxhmidp1 = shockprob*sum(simxhmiddiffp,2)/irfN1
	simxhhighp1 = shockprob*sum(simxhhighdiffp,2)/irfN1

	open(unit=110,file="simk.csv",action="write",status="replace")
	open(unit=120,file="simw.csv",action="write",status="replace")
	open(unit=130,file="simr.csv",action="write",status="replace")
	open(unit=140,file="simy.csv",action="write",status="replace")
	open(unit=150,file="simc.csv",action="write",status="replace")
	open(unit=160,file="siminv.csv",action="write",status="replace")
	open(unit=170,file="siml.csv",action="write",status="replace")
	open(unit=180,file="simh.csv",action="write",status="replace")
	open(unit=190,file="simz.csv",action="write",status="replace")
	open(unit=200,file="simtrans.csv",action="write",status="replace")
	open(unit=210,file="simyh.csv",action="write",status="replace")
	write(110,"(20000(f0.16,',',:))") simk1(irfdrop+1:)
	write(120,"(20000(f0.16,',',:))") simw1(irfdrop+1:)
	write(130,"(20000(f0.16,',',:))") simr1(irfdrop+1:)
	write(140,"(20000(f0.16,',',:))") simy1(irfdrop+1:)
	write(150,"(20000(f0.16,',',:))") simc1(irfdrop+1:)
	write(160,"(20000(f0.16,',',:))") siminv1(irfdrop+1:)
	write(170,"(20000(f0.16,',',:))") siml1(irfdrop+1:)
	write(180,"(20000(f0.16,',',:))") simh1(irfdrop+1:)
	write(190,"(20000(f0.16,',',:))") simz1(irfdrop+1:)
	write(200,"(20000(f0.16,',',:))") simtrans1(irfdrop+1:)
	write(210,"(20000(f0.16,',',:))") simyh1(irfdrop+1:)
	close(110)
	close(120)
	close(130)
	close(140)
	close(150)
	close(160)
	close(170)
	close(180)
	close(190)
	close(200)
	close(210)

	! disaggregated by productivity x
	open(unit=310,file="simxcons.csv",action="write",status="replace")
	open(unit=320,file="simxh.csv",action="write",status="replace")
	do ix = 1,nx
	    write(310,"(20000(f0.16,',',:))") simxc1(irfdrop+1:,ix)
	    write(320,"(20000(f0.16,',',:))") simxh1(irfdrop+1:,ix)
	end do
	close(310)
	close(320)

	open(unit=410,file="simxclow.csv",action="write",status="replace")
	open(unit=420,file="simxcmid.csv",action="write",status="replace")
	open(unit=430,file="simxchigh.csv",action="write",status="replace")
	open(unit=440,file="simxhlow.csv",action="write",status="replace")
	open(unit=450,file="simxhmid.csv",action="write",status="replace")
	open(unit=460,file="simxhhigh.csv",action="write",status="replace")
	write(410,"(20000(f0.16,',',:))") simxclow1(irfdrop+1:)
	write(420,"(20000(f0.16,',',:))") simxcmid1(irfdrop+1:)
	write(430,"(20000(f0.16,',',:))") simxchigh1(irfdrop+1:)
	write(440,"(20000(f0.16,',',:))") simxhlow1(irfdrop+1:)
	write(450,"(20000(f0.16,',',:))") simxhmid1(irfdrop+1:)
	write(460,"(20000(f0.16,',',:))") simxhhigh1(irfdrop+1:)
	open(unit=411,file="simxclowp.csv",action="write",status="replace")
	open(unit=421,file="simxcmidp.csv",action="write",status="replace")
	open(unit=431,file="simxchighp.csv",action="write",status="replace")
	open(unit=441,file="simxhlowp.csv",action="write",status="replace")
	open(unit=451,file="simxhmidp.csv",action="write",status="replace")
	open(unit=461,file="simxhhighp.csv",action="write",status="replace")
	write(411,"(20000(f0.16,',',:))") simxclowp1(irfdrop+1:)
	write(421,"(20000(f0.16,',',:))") simxcmidp1(irfdrop+1:)
	write(431,"(20000(f0.16,',',:))") simxchighp1(irfdrop+1:)
	write(441,"(20000(f0.16,',',:))") simxhlowp1(irfdrop+1:)
	write(451,"(20000(f0.16,',',:))") simxhmidp1(irfdrop+1:)
	write(461,"(20000(f0.16,',',:))") simxhhighp1(irfdrop+1:)


    call system_clock(cto2, cro)
    eptimeo = (dble(cto2-cto1)/dble(cro))/60.0d0
    write(*,"('  Total Elasped time (minutes) = ', F10.2)") eptimeo


end program calcirf
