clear
use Panel_1969-2015_with_unemp, replace

global period = 6  // 1-6 (if unempexc=0 then 2-6)
global unempexc = 1    // 1 exclude 
global fthours = 1000+500

global agemin = 22
global agemax = 64

// SRC(1000-2999) SEO(5000-7000) and 1997(3000-5000) new entry SEO also
keep if famid<3000
// Trim non-responsor
drop if htotearns==. 
replace htotearns=0 if htotearns<0

// drop top code of earnings in 1994 and 1995
drop if htotearns==9999999 &(year==1994 | year==1995)

// Calculate hourly wage (htotearns/wrkhrs)
gen hrlywage = htotearns / wrkhrs

// Inflation adjustment with CPI-U (base year=2000)
// Note that the reference year is a year before the survey year
gen prlevel = 0
replace prlevel = 4.9483 if year == 1969
replace prlevel = 4.6921 if year == 1970
replace prlevel = 4.4381 if year == 1971
replace prlevel = 4.2519 if year == 1972
replace prlevel = 4.1196 if year == 1973
replace prlevel = 3.8784 if year == 1974
replace prlevel = 3.4929 if year == 1975
replace prlevel = 3.2007 if year == 1976
replace prlevel = 3.0264 if year == 1977
replace prlevel = 2.8416 if year == 1978
replace prlevel = 2.6411 if year == 1979
replace prlevel = 2.3719 if year == 1980
replace prlevel = 2.0898 if year == 1981
replace prlevel = 1.8944 if year == 1982
replace prlevel = 1.7845 if year == 1983
replace prlevel = 1.7289 if year == 1984
replace prlevel = 1.6574 if year == 1985
replace prlevel = 1.6004 if year == 1986
replace prlevel = 1.5712 if year == 1987
replace prlevel = 1.5158 if year == 1988
replace prlevel = 1.4556 if year == 1989
replace prlevel = 1.3887 if year == 1990
replace prlevel = 1.3175 if year == 1991
replace prlevel = 1.2643 if year == 1992
replace prlevel = 1.2274 if year == 1993
replace prlevel = 1.1917 if year == 1994
replace prlevel = 1.1619 if year == 1995
replace prlevel = 1.1299 if year == 1996
replace prlevel = 1.0975 if year == 1997
replace prlevel = 1.0729 if year == 1998
replace prlevel = 1.0564 if year == 1999
replace prlevel = 1.0336 if year == 2000
replace prlevel = 1 if year == 2001
replace prlevel = 0.9723 if year == 2002
replace prlevel = 0.9572 if year == 2003
replace prlevel = 0.9359 if year == 2004
replace prlevel = 0.9116 if year == 2005
replace prlevel = 0.8817 if year == 2006
replace prlevel = 0.8542 if year == 2007
replace prlevel = 0.8307 if year == 2008
replace prlevel = 0.7998 if year == 2009
replace prlevel = 0.8028 if year == 2010
replace prlevel = 0.7895 if year == 2011
replace prlevel = 0.7657 if year == 2012
replace prlevel = 0.75 if year == 2013
replace prlevel = 0.7391 if year == 2014
replace prlevel = 0.7275 if year == 2015

* SAMPLE RESTRICTION

* household heads only
keep if headrel==1 | headrel==10

sort id year
by id: gen test=_n
by id: gen yeargap=year-year[_n-1]
by id: gen agegap=age-age[_n-1]
by id: replace age=age[_n-1]+yeargap if agegap!=yeargap
drop agegap

xtset id year

* very low wage
// Drop samples having wages lower than a half of the minimum wage
// Note that the reference year is a year before the survey year

/*
drop if hrlywage< 1.6 *0.5 & year <=1974 
drop if hrlywage< 2.1 *0.5 & year >= 1975 & year <= 1976 
drop if hrlywage< 2.3*0.5 & year >=1977 & year <= 1978
drop if hrlywage<2.65*0.5 & year==1979
drop if hrlywage<2.9*0.5 & year==1980
drop if hrlywage<3.1*0.5 & year==1981
drop if hrlywage<3.35*0.5 & year==1982
drop if hrlywage<3.8*0.5 & year>=1983 & year<=1991
drop if hrlywage<4.25*0.5 & year==1992
drop if hrlywage<4.75*0.5 & year>=1993 & year<=1997
drop if hrlywage<5.15*0.5 & year>=1998 & year<=2007
drop if hrlywage<5.85*0.5 & year==2008 
drop if hrlywage<6.55*0.5 & year==2009 
drop if hrlywage<7.25*0.5 & year>=2010 
*/

* self-employed
drop if selfemp == 3

gen fullempst=0
replace fullempst=1 if wrkhrs >= $fthours
sum fullempst

// There is an issue in the data. The spell of unemployment was reported 
// as hours until 1993, but it changes to weeks from 1993. 
// I choose 8*5*5 hours for the criteria of severe unemployments by 1993
// I chooose 5 weeks for the criteria of severe unemployment from 1994.

// Adjust the inflation on earnings with CPI-U (base year= 2000)
replace htotearns = htotearns * prlevel
replace hrlywage = hrlywage * prlevel
replace networth = networth * prlevel

sort year
table year, c(m htotearns)
table year, c(m fullempst)

// calculate the auto-correation of full employment
// Calculate the mean of full employment
egen murho=mean(fullempst)
// Calculate the variance of full employment
egen varrho=sd(fullempst)
replace varrho=varrho*varrho

// calculate the auto-correation of full employment
sort id year
by id: gen fullmpstf=fullempst[_n+1]
by id: gen fullempstcross=(fullempst-murho)*(fullmpstf-murho)
egen avgfullempstcross=mean(fullempstcross)
gen autocorrrho=avgfullempstcross/varrho
sum autocorrrho
// Auto-correlation 
drop fullmpstf fullempstcross avgfullempstcross autocorrrho varrho murho selfemp empst


****************************************************
if $period == 1 {
keep if (year == 1970 | year == 1972)
}
if $period == 2 {
keep if (year == 1974 | year == 1977)
}
if $period == 3 {
keep if (year == 1981 | year == 1984)
}
if $period == 4 {
keep if (year == 1991 | year == 1993)
}
if $period == 5 {
keep if (year == 2001 | year == 2003)
}
if $period == 6 {
keep if (year == 2007 | year == 2011)
}


****************************************************
sort id
by id: egen sumunempspell = sum(unempspell)
by id: gen panel = _N

egen maxN = max(panel)
keep if panel == maxN

reshape wide headrel sex educ sizefam hwage htotearns wtotearns trans /*
*/ wrkhrs age networth famid indid x11102_ hrlywage prlevel fullempst/*
*/ unempspell test yeargap sumunempspell, i(id) j(year)

////////// Note that a survey year is a year after the actual year

*egen qtwage1981 = xtile(hrlywage1981) if hrlywage1981>0 & age1981<70, n(5) 
*egen qtwage1990 = xtile(hrlywage1990) if hrlywage1990>0 & age1990<70, n(5) 
*egen qtwage2001 = xtile(hrlywage2001) if hrlywage2001>0 & age2001<70, n(5) 


if $period == 1 {
* recession 1
keep if age1970>=$agemin & age1970<=$agemax
egen qtwage1970 = xtile(hrlywage1970) if hrlywage1970>0, n(5) 
}

if $period == 2 {
* recession 2
keep if age1974>=$agemin & age1974<=$agemax
egen qtwage1974 = xtile(hrlywage1974) if hrlywage1974>0, n(5) 
if $unempexc == 1{
drop if sumunempspell1974 > 0
}
}

if $period == 3 {
* recession 3
keep if age1981>=$agemin & age1981<=$agemax
egen qtwage1981 = xtile(hrlywage1981) if hrlywage1981>0, n(5) 
if $unempexc == 1{
drop if sumunempspell1981 > 0
}
}

if $period == 4 {
* recession 4
keep if age1991>=$agemin & age1991<=$agemax
egen qtwage1991 = xtile(hrlywage1991) if hrlywage1991>0, n(5) 
if $unempexc == 1{
drop if sumunempspell1991 > 0
}
}

if $period == 5 {
* recession 5
keep if age2001>=$agemin & age2001<=$agemax
egen qtwage2001 = xtile(hrlywage2001) if hrlywage2001>0, n(5) 
if $unempexc == 1{
drop if sumunempspell2001 > 0
}
}

if $period == 6 {
* recession 6
keep if age2007>=$agemin & age2007<=$agemax
egen qtwage2007 = xtile(hrlywage2007) if hrlywage2007>0, n(5) 
if $unempexc == 1{
drop if sumunempspell2007 > 0
}
}
 
if $period == 1 {
table qtwage1970, c(m fullempst1970 m fullempst1972) 
su qtwage1970 if qtwage1970>0
}

if $period == 2 {
table qtwage1974, c(m fullempst1974 m fullempst1977) 
su qtwage1974 if qtwage1974>0
}

if $period == 3 {
table qtwage1981, c(m fullempst1981 m fullempst1984) 
su qtwage1981 if qtwage1981>0
}

if $period == 4 {
table qtwage1991, c(m fullempst1991 m fullempst1993) 
su qtwage1991 if qtwage1991>0
}

if $period == 5 {
table qtwage2001, c(m fullempst2001 m fullempst2003) 
su qtwage2001 if qtwage2001>0
}

if $period == 6 {
table qtwage2007, c(m fullempst2007 m fullempst2011) 
su qtwage2007 if qtwage2007>0
}
