clear;

% generated at https://plotdigitizer.com/app
data = importdata('./ReservationRaise/plot-data.csv');  % import data
x = data.data(:,1);
y = data.data(:,2);

raise= linspace(-1,2,601);

% model-generated data (output from fortran)
cdf_HAT_orig = importdata('ReservationRaise/f90/revcdf.csv'); 

% smoothing CDFs
cdf_HAT=smoothdata(cdf_HAT_orig,'movmean',5);

% arc elasticity
indzero = sum(raise<=0);
num = length(raise);

arc_HAT = zeros(num,1);

for i=1:num
    arc_HAT(i) = ( (cdf_HAT(i)-cdf_HAT(indzero))/cdf_HAT(indzero) )/(raise(i)-raise(indzero));
    
end

% Figure 2
nfig2 = 2*0.195/0.01+1;
fig2grid = linspace(-0.195,0.195,nfig2);
fig2val = zeros(1,nfig2);
for i=1:nfig2
    ind = sum(raise<=fig2grid(i));
    fig2val(i) = arc_HAT(ind);
end

plot(x,y,'bo-',fig2grid,fig2val,'r^--'); xlabel('Change in Aggregate Raise (\Xi)'); ylabel('Implied Arc Elasticity');
legend('Data','Model','Location','NorthEast');
grid on;




