clear;

T = 60;
thickness0 = 3.0;
thickness = 3.0;

zerovec = zeros(1,T);
timevec = linspace(1,T,T);

figure;
subplot(121)
load ./HSV_HAT/irfneg/simw.csv
plot(timevec,simw(2:T+1),'LineWidth',thickness0); xlabel('Quarter'); ylabel('% deviation from s.s.')
hold on
load ./HSV_HAN/irfneg/simw.csv
plot(timevec,simw(2:T+1),'r--','LineWidth',thickness)
hold on
load ./HSV_HAF/irfneg/simw.csv
plot(timevec,simw(2:T+1),'g:','LineWidth',thickness)
hold on
load ./JSYrep/repirf.mat simw;
plot(timevec,log(simw(2:T+1)/simw(1))*100,'m-.','LineWidth',thickness)
hold on;
plot(timevec,zerovec,'k:','LineWidth',0.5); ylim([-2.0 0.5])
title('Wage');


subplot(122)
load ./HSV_HAT/irfneg/simr.csv
plot(timevec,simr(2:T+1),'LineWidth',thickness0); xlabel('Quarter'); ylabel('% point deviation from s.s.')
hold on
load ./HSV_HAN/irfneg/simr.csv
plot(timevec,simr(2:T+1),'r--','LineWidth',thickness); ylim([-0.2 0.05])
hold on
load ./HSV_HAF/irfneg/simr.csv
plot(timevec,simr(2:T+1),'g:','LineWidth',thickness); ylim([-0.2 0.05])
hold on
load ./JSYrep/repirf.mat simr;
plot(timevec,(simr(2:T+1)-simr(1))*100,'m-.','LineWidth',thickness)
hold on;
plot(timevec,zerovec,'k:','LineWidth',0.5)
title('Interest rate');
legend('Model (HA-T)','Model (HA-N)','Model (HA-F)','Model (RA)','Location','SouthEast');


figure;
subplot(231)
load ./HSV_HAN/irfneg/simz.csv
plot(timevec,simz(2:T+1),'k-','LineWidth',thickness); xlabel('Quarter'); ylabel('% deviation from s.s.')
title('TFP')
hold on
plot(timevec,zerovec,'k:','LineWidth',0.5); ylim([-2.5 0.25])

subplot(232)
load ./HSV_HAT/irfneg/simy.csv
plot(timevec,simy(2:T+1),'LineWidth',thickness0);  xlabel('Quarter')
hold on
load ./HSV_HAN/irfneg/simy.csv
plot(timevec,simy(2:T+1),'r--','LineWidth',thickness)
hold on
load ./HSV_HAF/irfneg/simy.csv
plot(timevec,simy(2:T+1),'g:','LineWidth',thickness)
hold on
plot(timevec,zerovec,'k:','LineWidth',0.5); ylim([-4.0 0.4])
title('Output');

subplot(233)
load ./HSV_HAT/irfneg/simc.csv
plot(timevec,simc(2:T+1),'LineWidth',thickness0); xlabel('Quarter')
hold on
load ./HSV_HAN/irfneg/simc.csv
plot(timevec,simc(2:T+1),'r--','LineWidth',thickness)
hold on
load ./HSV_HAF/irfneg/simc.csv
plot(timevec,simc(2:T+1),'g:','LineWidth',thickness)
hold on
plot(timevec,zerovec,'k:','LineWidth',0.5); ylim([-1.5 0.15])
title('Consumption');

subplot(234)
load ./HSV_HAT/irfneg/simh.csv
plot(timevec,simh(2:T+1),'LineWidth',thickness0); xlabel('Quarter'); ylabel('% deviation from s.s.')
hold on
load ./HSV_HAN/irfneg/simh.csv
plot(timevec,simh(2:T+1),'r--','LineWidth',thickness)
hold on
load ./HSV_HAF/irfneg/simh.csv
plot(timevec,simh(2:T+1),'g:','LineWidth',thickness)
hold on
plot(timevec,zerovec,'k:','LineWidth',0.5); ylim([-2.5 0.5])
title('Total hours');

subplot(235)
load ./HSV_HAT/irfneg/simyh.csv
plot(timevec,simyh(2:T+1),'LineWidth',thickness0); xlabel('Quarter')
hold on
load ./HSV_HAN/irfneg/simyh.csv
plot(timevec,simyh(2:T+1),'r--','LineWidth',thickness)
hold on
load ./HSV_HAF/irfneg/simyh.csv
plot(timevec,simyh(2:T+1),'g:','LineWidth',thickness)
hold on
plot(timevec,zerovec,'k:','LineWidth',0.5); ylim([-2.5 0.5])
title('Avg labor productivity');

subplot(236)
load ./HSV_HAT/irfneg/siminv.csv
plot(timevec,siminv(2:T+1),'LineWidth',thickness0); xlabel('Quarter')
hold on
load ./HSV_HAN/irfneg/siminv.csv
plot(timevec,siminv(2:T+1),'r--','LineWidth',thickness)
hold on
load ./HSV_HAF/irfneg/siminv.csv
plot(timevec,siminv(2:T+1),'g:','LineWidth',thickness)
hold on
plot(timevec,zerovec,'k:','LineWidth',0.5); ylim([-15 3])
title('Investment');
legend('Model (HA-T)','Model (HA-N)','Model (HA-F)','Location','SouthEast');