module mod_calcss

use mod_utils
use mod_spline
use mod_policies
use mod_parameters
implicit none


contains


subroutine calcss(murand,xrand,agrid,kgrid,xgrid,pxij,xss,ALOW, &
	w,r,Lagg,Kagg,Yagg,TY,TrY,Tragg,mumat,ndist,Ks,Ls,EPratio,TrInc5,TrW5,EmpW5,stdlogwage,stdlogearn,rhoxest,error, &
	ALPHA,DELTA,HBAR,phi,B0,RHOX,SDINOVX,kappa1,kappa2,Trscale,Transprog1,Transprog2,T0, &
	tol,tolss,toldist,maxiter,dampss0,congrid,deggrida,deggridk,diagflag,diagnum,logdiff,tauflag,calcma,linflag,howflag,hsvflag,mx, &
    cmatw,cmatn,cwmat,cnmat,Vmat)


	integer, parameter :: savessresult = 1
	integer, parameter :: calcdistsim = 1
	integer, parameter :: calcmasim = 0

	real(8), intent(in) :: murand(:), xrand(:)
	real(8), intent(out) :: agrid(:), kgrid(:), xgrid(:), pxij(:,:), xss(:), ALOW
	real(8), intent(out) :: w, r, Lagg, Kagg, Yagg, TY, TrY, Tragg, mumat(:,:), ndist(:,:), Ks, Ls, EPratio, TrInc5(:), TrW5(:), EmpW5(:), stdlogwage, stdlogearn, rhoxest
    real(8), intent(out) :: cmatw(:,:), cmatn(:,:), cwmat(:,:), cnmat(:,:), Vmat(:,:)
	integer, intent(out) :: error

	real(8), intent(in) :: ALPHA, DELTA, HBAR, phi, B0, RHOX, SDINOVX, kappa1, kappa2, Trscale, Transprog1, Transprog2, T0
	real(8), intent(in) :: tol, tolss, toldist, dampss0, deggrida, deggridk, mx
	integer, intent(in) :: maxiter, diagflag, diagnum, congrid, logdiff, tauflag, calcma, linflag, howflag, hsvflag

	integer nx, na, nk, howard, howardcnt
    real(8), allocatable :: Vmatss(:,:), Wmatss(:,:), Nmatss(:,:)
    real(8), allocatable :: apmat(:,:), awpmat(:,:), anpmat(:,:), lmat(:,:), awpmat1(:,:), anpmat1(:,:), kgrid1(:)
    real(8), allocatable :: apmatnew(:,:), awpmatnew(:,:), anpmatnew(:,:), lmatnew(:,:)
    real(8), allocatable :: TVmatss(:,:), TWmatss(:,:), TNmatss(:,:)

    integer ix, jx, ia, ik, jk, kk, iteration, iterationout, i, multhres
    real(8) khigh, khighnew, Kratio, xnow, anow, ap, atilde, kwhigh, knhigh, awp, anp, TW, TN, earns, tax, Tr, Trw, Trn, wk, EPquarter, EPannual, E2E, N2N, negW, cw, cn
	! real(8) mklow, mkhigh, mk0, WNdiffL, WNdiffH, WNdiff0
    real(8) distance, distanceout, damp, wnmax, wnmin, distancevec(maxiter), distancedamp, taxw, taxn, taxtemp
    integer, allocatable :: jkmat(:,:)
	real(8), allocatable :: EV(:), Tmumat(:,:), wkmat(:,:), muk(:), minasseta(:), minassetd(:), minasset(:), minwage(:,:)

    real(8) musum, Ys, Govt, KY, TaxY, Taxagg, Giniwage, Giniearns, Giniwealth, distpolmax(3), distpolmean(3), EPsim, TrIncInc51, TrIncInc52, TrIncInc53, TrIncInc54, TrIncInc55
    real(8) ShareW51, ShareW52, ShareW53, ShareW54, ShareW55, EmpW51, EmpW52, EmpW53, EmpW54, EmpW55, TrInc51, TrInc52, TrInc53, TrInc54, TrInc55, TrW51, TrW52, TrW53, TrW54, TrW55, objval
    
    ! for reservation raise
    real(8) netearn

	! for SimulSS_v4b
    
    real(8) distind(NS), temp(NS), asim(NS,T+1)
    integer xsimind(NS,T), xsimindnow(NS), xsimindnext(NS), xsimtemp(1), xindnow(NS)
    integer, allocatable :: xindnext(:,:), xindcount(:)
    integer asimindtemp, maxsimind
    real(8) worksim(NS,T), consim(NS,T), earningsim(NS,T), wagesim(NS,T), wage0sim(NS,T), incomesim(NS,T), postincomesim(NS,T), Trsim(NS,T), Taxsim(NS,T), fulltimesim(NS), resrsim(NS)
    real(8) Et(T), EPt(T)
    ! real(8) atilde, anow, xnow, Tr, EPsim, stdlogwage, stdlogearn
	! real(8) EPsim, stdlogwage, stdlogearn
    real(8) anwagesim(NS,yT), anearnsim(NS,yT), fulltime(NS,yT), logwage(NS,yT), logearn(NS,yT)
    real(8) lnwagetemp(yT), lnwagelagtemp(int(NS*T/4))
    real(8), allocatable :: mumeasure(:), logwage_active(:), logearn_active(:), lnwagesim(:), lnwagelagsim(:), X(:,:)
    real(8) XX(2,2), Xy(2), estimate(2) !, rhoxest
    integer Nactive, count_active, time, ytime, EE, EN, NEsum, NN
    ! ! vsl
	! integer, parameter :: method = VSL_RNG_METHOD_UNIFORM_STD
    ! integer errcode, brng, seed
    ! type(vsl_stream_state) :: stream
	! real(8), allocatable :: murand(:), xrand(:)

	integer cto1, cto2, cro
    real(8) eptimeo
    integer ct1, ct2, cr
    real(8) eptime

	! for dgetrf, dgetri
    integer ra, INFO
    integer, allocatable :: IPIV(:)
    real(8), allocatable :: invTa(:,:), cfa(:,:), WORK(:)


	call system_clock(cto1, cro)
	
	nx = size(xgrid,1)
	na = size(agrid,1)
	nk = size(kgrid,1)
	
	allocate(Vmatss(na,nx),Wmatss(na,nx),Nmatss(na,nx))
	allocate(apmat(na,nx),awpmat(na,nx),anpmat(na,nx),lmat(na,nx))
    allocate(apmatnew(na,nx),awpmatnew(na,nx),anpmatnew(na,nx),lmatnew(na,nx))
	allocate(TVmatss(na,nx),TWmatss(na,nx),TNmatss(na,nx),EV(na))
	allocate(Tmumat(nk,nx),jkmat(nk,nx),wkmat(nk,nx),muk(nk),minasseta(nx),minassetd(nx),minasset(nx),minwage(na,nx))
    allocate(awpmat1(nk*10,nx),anpmat1(nk*10,nx),kgrid1(nk*10))
	ra = na-2
    allocate(invTa(ra,ra),cfa(4,ra+1),IPIV(ra),WORK(ra))


	print *, "  STEADY STATE"
	if (linflag==0) print *, "  NOTE: spline interpolation is used for a"
	if (linflag==1) print *, "  NOTE: linear interpolation is used for a"
	if (calcma==0) print *, "  NOTE: maximized values are used to calculate distribution"
	if (calcma==1) print *, "  NOTE: minasset (with descending order search) is used to calculate distribution"
	if (calcma==2) print *, "  NOTE: minasset (with ascending order search) is used to calculate distribution"
    
	
	! grids for labor productivity
    print *,' nx ', nx
	if (tauflag==1) then
		call tauchen(nx,0.0d0,RHOX,SDINOVX,mx,xgrid,pxij)
        print *,' mx ', mx
	elseif (tauflag==0) then
		call rouwenhorst(RHOX,SDINOVX,nx,xgrid,pxij)
	end if
    pxij = max(pxij,0.0d0)
    xgrid = exp(xgrid)
    call markovss(pxij,nx,tol,xss)
    write(*,"('  xgrid =', F10.5)") xgrid
    !write(*,"('  pxij =', F10.5)") pxij
    write(*,"('  xss =', F10.5)") xss
    
    


    !  OUTER LOOP: find equilibrium prices
    ! initial guess for L (not important)
    Lagg = 0.37d0
    ! 8 May 2018: initial guesses for r
    r = 0.01d0


    ! initial guess for the value function
	! NOTE: The value function converged in the previous inner loop is used as an initial guess in the current inner loop
	! We need an initial guess for the value function for the first time
    Vmatss = 0.0d0

	! initial distribution
 	! 26 Feb 2018: needed for values in the other cells of mumat, otherwise random values are set
	mumat = 0.0d0
	do ix = 1,nx
        mumat(11:20,ix) = 0.1d0/dble(nx)
    end do

    distanceout = 1d+4
    iterationout = 1
    damp = dampss0 ! NOTE: needed?

    error = 0


    do while (distanceout > tolss)

        ! Kagg and w consistent with firm FOC
        Kagg = Lagg*( ((r + DELTA)/ALPHA )**(1.0d0/(ALPHA-1.0d0)) )
        w = (1.0d0**(1.0d0/(1.0d0-ALPHA)))*(1.0d0-ALPHA)*(((r+DELTA)/ALPHA)**(ALPHA/(ALPHA-1.0d0)))

		Yagg= (Kagg**(ALPHA))*(Lagg**(1.d0-ALPHA))
        !ALOW = -phi*Yagg
        !ALOW = blimit
        !ALOW = - 0.120d0/(1.0d0+r)
        
        ! Default option for borrowing limits
        if ((Trscale > 0.0d0)) then
            ALOW = - T0/(1.0d0+r)            
            !ALOW = 0.0d0
        else
            ! Note 20210208 use baseline value
            ALOW = - T0Baseline/(1.0d0+r)
        end if
        
		! for a below atilde, not-working is not feasible (consumption negative)
   !     if (Trscale == 0.0d0) then
   !         atilde = (alow)/(1.0d0+r)
   !     else
			!! maximum transfer to those with no wealth
   !         call transfers(0.0d0,0.0d0,r,w,0.0d0,Yagg,Trscale,Transprog1,Transprog2,T0,Trn)
   !         atilde = (alow - Trn)/(1.0d0+r)
   !     end if

        ! adaptive maximum of grids
        if (iterationout == 1) then
            khigh = Kagg*50.0d0
        else

			! NOTE: find maximum ik so that muk(ik)>0
            do ik = 1,nk
                if (muk(nk-ik+1)>toldist**2.0d0) exit
            end do

            khighnew = min(0.3d0*khigh + (0.7d0)*kgrid(nk-ik+1)*1.3d0,50.0d0*Kagg)

            !if  ((abs(log(khighnew)-log(khigh)) > 0.05d0) .and. (iterationout < 20)) then
            if  ((iterationout < 20)) then
                khigh = khighnew
            end if

		end if

        Kratio = khigh/Kagg

		write(*,*) " "
		print *,'===================================================================='
		print *,' iteration ', iterationout
		write(*,"('  r =', F10.5, '    w =', F10.5, '   blimit =', F10.5)") r, w, alow
        write(*,"('  khigh over K =', F10.2)") Kratio

		! grids for assets
		if (congrid==1) then
			! more grid points concentrated toward the left
			agrid = logspace(0.0d0,deggrida,na) - 10.0d0**(0.0d0)
			agrid = agrid/(10.0d0**deggrida - 10.0d0**0.0d0)
			agrid = agrid*(khigh-alow) + alow
            kgrid = logspace(0.0d0,deggridk,nk) - 10.0d0**(0.0d0)
			kgrid = kgrid/(10.0d0**deggridk - 10.0d0**0.0d0)
			kgrid = kgrid*(khigh-alow) + alow
		else
	        agrid = logspace(log(ALOW - 1.0d0*ALOW + 1.0d0)/log(10.0d0), log(khigh - 1.0d0*ALOW + 1.0d0)/log(10.0d0), na)
	        agrid = agrid + ALOW - 1.0d0
	        kgrid = logspace(log(ALOW - 1.0d0*ALOW + 1.0d0)/log(10.0d0), log(khigh - 1.0d0*ALOW + 1.0d0)/log(10.0d0), nk)
	        kgrid = kgrid + ALOW - 1.0d0
        end if

		! setup spline
		invTa = spbas(ra,agrid)
		call dgetrf(ra,ra,invTa,ra,IPIV,INFO)
	    call dgetri(ra,invTa,ra,IPIV,WORK,ra,INFO)
		

		! INNER LOOP: value function iteration
		if (diagflag==1) print *, " "
        distance = 1d+4
        howard = 0
        howardcnt = 0

        apmat = 0.0d0
	    awpmat = 0.0d0
	    anpmat = 0.0d0
	    lmat = 0.0d0

        call system_clock(ct1, cr)

		do iteration = 1,maxiter

            !$omp parallel do default(shared) private(ix,xnow,EV,jx,cfa,ia,anow,awp,anp,TW,TN,cw,cn)
			do ix = 1,nx
				
                xnow = xgrid(ix)

                ! compute conditional expected value functions on grid points
                EV = 0.0d0
                do jx = 1,nx
                    EV = EV + pxij(ix,jx)*reshape(Vmatss(:,jx),(/na/))
                end do

				! fit spline
				if (linflag==0) cfa = spfit(invTa,EV,ra,agrid)

                do ia = 1,na

                    anow = agrid(ia)
                    awp = awpmat(ia,ix)
                    anp = anpmat(ia,ix)

					call calcwnval(xnow,anow,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,agrid,cfa,EV,tol,linflag,howard,hsvflag,awp,anp,TW,TN,cw,cn)

					TWmatss(ia,ix) = TW
					TNmatss(ia,ix) = TN
                    awpmatnew(ia,ix) = awp
                    anpmatnew(ia,ix) = anp
                    cwmat(ia,ix) = cw
                    cnmat(ia,ix) = cn

                end do

            end do
            !$omp end parallel do

            ! computing TV
            do ia = 1,na
                do ix= 1,nx
                    if (TWmatss(ia,ix) > TNmatss(ia,ix)) then
                        TVmatss(ia,ix) = TWmatss(ia,ix)
                        apmatnew(ia,ix) = awpmatnew(ia,ix)
                        lmatnew(ia,ix) = 1
                    else
                        TVmatss(ia,ix) = TNmatss(ia,ix)
                        apmatnew(ia,ix) = anpmatnew(ia,ix)
                        lmatnew(ia,ix) = 0
                    end if

                end do

            end do


            distance = maxval(maxval(abs(TVmatss-Vmatss),1),1)
            
            distpolmax(1) = maxval(maxval(abs(awpmatnew-awpmat),1),1)
		    distpolmean(1) = sum(sum(abs(awpmatnew-awpmat),1),1)
		    distpolmax(2) = maxval(maxval(abs(anpmatnew-anpmat),1),1)
		    distpolmean(2) = sum(sum(abs(anpmatnew-anpmat),1),1)
		    distpolmax(3) = maxval(maxval(abs(lmatnew-lmat),1),1)
		    distpolmean(3) = sum(sum(abs(lmatnew-lmat),1),1)

            distancevec(iteration) = distance

            Vmatss = TVmatss
            Wmatss = TWmatss
            Nmatss = TNmatss
            apmat = apmatnew
		    awpmat = awpmatnew
		    anpmat = anpmatnew
		    lmat = lmatnew

            ! diagnosis
            if (mod(iteration,diagnum)==0 .and. diagflag==1) then

				! write(*,"('  iteration ', I4, '   ||TV-V|| = ', F8.5, ' max(W-N) = ', F8.5, ' min(W-N) = ', F8.5)") &
				! iteration, distance, wnmax, wnmin
				write(*,"('  iteration ', I4, '   ||TV-V|| = ', F10.8)") &
				iteration, distance
                write(*,"('          ||Tawp-awp||   ||Tanp-anp||   ||Tlmat-lmat|| = ( ', F8.5, ', ', F8.5, ', ', F8.5, ')')") distpolmax
			    !write(*,"('          sum|Tawp-awp|  sum|Tanp-anp|  sum|Tlmat-lmat|= ( ', F8.5, ', ', F8.5, ', ', F8.5, ')')") distpolmean
			    write(*,"('          Howard''s improvement algorithm: ', I2)") howardcnt
			    print *, howard

            end if

			if ((distance<=tol) .or. (iteration==maxiter)) then

				if (diagflag==1) then
					print *, " "
					if (iteration<maxiter) then
						print *, "  Value function iteration converged:"
					else
						print *, "  Maximum number of iterations reached:"
					end if
					do i=max(iteration-2,1),iteration
						write(*,"('  iteration ', I4, '   ||TV-V|| = ', F10.8)") &
		            	i, distancevec(i)
					end do
				end if

				exit

            end if

         

            if (howflag==1) then

			    if (howard==0) then
				    ! print *, "  Howard''s improvement algorithm starts"
				    ! pause
				    howard = 1
			    end if

			    if (howard==1) then

				    howardcnt = howardcnt + 1
				    if (howardcnt>iteration/10) then
					    howard = 0
					    howardcnt = 0
				    end if

			    end if

		    end if

        end do

        call system_clock(ct2, cr)
        eptime = dble(ct2-ct1)/cr
        if (diagflag==1) write(*,"('  VFI Elasped time = ', F10.5)") eptime
		if (diagflag==1) print *, " "
		! pause


		! if (calcma>0) then
			! ****************************************
			! threshold asset for work decision
			minasseta = 0.0d0 ! ascending order
			minassetd = 0.0d0 ! descending order
	        minasset = 0.0d0

	        do ix = 1,nx

	            xnow = xgrid(ix)

	            ! compute conditional expected value functions on grid points
	            EV = 0.0d0
	            do jx = 1,nx
	                EV = EV + pxij(ix,jx)*reshape(Vmatss(:,jx),(/na/))
	            end do

	            ! fit spline
				if (linflag==0) cfa = spfit(invTa,EV,ra,agrid)

				minasseta(ix) = bisectma(agrid,cfa,EV,Wmatss(:,ix),Nmatss(:,ix),xnow,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,tol,1,linflag,hsvflag)
				minassetd(ix) = bisectma(agrid,cfa,EV,Wmatss(:,ix),Nmatss(:,ix),xnow,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,tol,0,linflag,hsvflag)

				if (calcma==1) then
					minasset = minassetd
				! NOTE: if calcma=0, use asc-order minasset
				else !if (calcma==2) then
					minasset = minasseta
	            end if

	        end do ! ix loop

			if (sum(abs(minasseta-minassetd),1)>tol) then
	            ! write(*,"('  multiple thresholds at bisection ', I4)") countmkt
				! write(*,"('  we are using the ones found by descending order search ')")
			 	! do ix = 1,nx
			 	! 	diffma = abs(minasseta(ix)-minassetd(ix))
			 	! 	if (diffma>0) print *, ix, minasseta(ix), minassetd(ix)
	            ! end do
				multhres = 1
			else
				multhres = 0
	        end if

		! end if


		! ****************************************
        ! stationary distribution based on minasset (calcma>0) or maximation (calcma==0)
        distance = 1d+4
        call system_clock(ct1, cr)

		! do iteration = 1,100 !2*maxiter
		do iteration = 1,2*maxiter

            !$omp parallel do private(ix,xnow,EV,jx,cfa,ik,anow,Trw,Trn,kwhigh,knhigh,jk,wk,ap,taxw,taxn,awp,anp,TW,TN)
			do ix = 1,nx
                xnow = xgrid(ix)
                ! compute conditional expected value functions on grid points
                EV = 0.0d0
                do jx = 1,nx
                    EV = EV + pxij(ix,jx)*reshape(Vmatss(:,jx),(/na/))
                end do

                ! fit spline
			    if (linflag==0) cfa = spfit(invTa,EV,ra,agrid)

                do ik = 1,nk

                    anow = kgrid(ik)

					if (calcma>0) then

	                    if (anow >= minasset(ix)) then
	                        ! Not work
							ndist(ik,ix) = 0.0d0
							call transfers(xnow,anow,r,w,0.0d0,Yagg,Trscale,Transprog1,Transprog2,T0,Trn)
	                        call taxfunc(0.0d0,anow,r,Yagg,kappa1,kappa2,hsvflag,taxn)
	                        knhigh = (1.0d0+r)*anow - taxn + Trn
	                        !call gss(ALOW,knhigh,ap,tol/100.d0,0,linflag,anow,xnow,agrid,cfa,EV,w,r,taxn,Trn,B0,Hbar,kappa2)
                            call gssout(ALOW,knhigh,ap,tol/100.d0,0,linflag,anow,xnow,agrid,cfa,EV,w,r,taxn,Trn,B0,Hbar,kappa2)
	                    else
	                        ! Work
							ndist(ik,ix) = HBAR
							call transfers(xnow,anow,r,w,HBAR,Yagg,Trscale,Transprog1,Transprog2,T0,Trw)
	                        call taxfunc(w*xnow*HBAR,anow,r,Yagg,kappa1,kappa2,hsvflag,taxw)
	                        kwhigh = w*xnow*HBAR + (1.0d0+r)*anow - taxw + Trw
	                        call gss(ALOW,kwhigh,ap,tol/100.d0,1,linflag,anow,xnow,agrid,cfa,EV,w,r,taxw,Trw,B0,Hbar,kappa2)
                            call gssout(ALOW,kwhigh,ap,tol/100.d0,1,linflag,anow,xnow,agrid,cfa,EV,w,r,taxw,Trw,B0,Hbar,kappa2)
	                    end if

					else

						call calcwnval(xnow,anow,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,agrid,cfa,EV,tol,linflag,0,hsvflag,awp,anp,TW,TN,cw,cn)
                        

						if (TW>TN) then
							! Work
							ndist(ik,ix) = HBAR
							call transfers(xnow,anow,r,w,HBAR,Yagg,Trscale,Transprog1,Transprog2,T0,Trw)
	                        call taxfunc(w*xnow*HBAR,anow,r,Yagg,kappa1,kappa2,hsvflag,taxw)
	                        kwhigh = w*xnow*HBAR + (1.0d0+r)*anow - taxw + Trw
							ap = awp
	                        ! call gss(ALOW,kwhigh,ap,tol/100.d0,1,linflag,anow,xnow,agrid,cfa,EV,w,r,taxw,Trw,B0,Hbar,kappa2)
	                    else
							! Not work
							ndist(ik,ix) = 0.0d0
							call transfers(xnow,anow,r,w,0.0d0,Yagg,Trscale,Transprog1,Transprog2,T0,Trn)
	                        call taxfunc(0.0d0,anow,r,Yagg,kappa1,kappa2,hsvflag,taxn)
	                        knhigh = (1.0d0+r)*anow - taxn + Trn
							ap = anp
	                        ! call gss(ALOW,knhigh,ap,tol/100.d0,0,linflag,anow,xnow,agrid,cfa,EV,w,r,taxn,Trn,B0,Hbar,kappa2)
	                    end if

					end if

                    ! NOTE: finding indices and weights on grid points of k in the next periods
					! Ref. Young (2010?) and Rios-Rull (1999?)
					call findjw(ap,kgrid,jk,wk)
					jkmat(ik,ix) = jk
					wkmat(ik,ix) = wk

                end do

            end do
            !$omp end parallel do

			! transition
			Tmumat = 0.0d0
			do ix = 1,nx
				
				do ik = 1,nk

					if (mumat(ik,ix) > 0.0d0) then

						jk = jkmat(ik,ix)
						wk = wkmat(ik,ix)

						do jx = 1,nx
							
							Tmumat(jk,jx) = Tmumat(jk,jx) + pxij(ix,jx)*wk*mumat(ik,ix)
							Tmumat(jk+1,jx) = Tmumat(jk+1,jx) + pxij(ix,jx)*(1.0d0-wk)*mumat(ik,ix)

						end do

					end if

				end do

			end do

			if (logdiff==1) then
            	distance = maxval(maxval(log(Tmumat)-log(mumat),1),1)
			else
            	distance = maxval(maxval(Tmumat-mumat,1),1)
			end if
            mumat = Tmumat
            musum = sum(sum(mumat,1),1)

			distancevec(iteration) = distance

            if (mod(iteration,diagnum)==0 .and. diagflag==1) then

				write(*,"('  iteration ', I4, '   ||Tmu-mu|| = ', F10.8, '  sum(mu) = ', F10.8)") &
				iteration, distance, musum

            end if

			if ((distance<=toldist) .or. (iteration==maxiter)) then

				if (diagflag==1) then
					print *, " "
					if (iteration<maxiter) then
						print *, "  Distribution iteration converged:"
					else
						print *, "  Maximum number of iterations reached:"
					end if
					do i=max(iteration-2,1),iteration
						write(*,"('  iteration ', I4, '   ||Tmu-mu|| = ', F10.8)") &
						i, distancevec(i)
					end do
				end if

				exit

			end if

        end do

        call system_clock(ct2, cr)
        eptime = dble(ct2-ct1)/cr
        if (diagflag==1) write(*,"('  Distribution Elasped time = ', F10.5)") eptime


		! ****************************************
		! calculate aggregate variables
        muk = sum(mumat,2)

        Ks = 0.0d0
        do ik = 1,nk
            Ks = Ks + muk(ik)*kgrid(ik)
        end do

        Ls = 0.0d0
        do ix = 1,nx			
            Ls = Ls + sum(mumat(:,ix)*ndist(:,ix)*xgrid(ix),1)
        end do

        EPratio = sum(sum(mumat*ndist/HBAR,1),1)
		! NOTE: Ys is output implied by the supply side
        Ys = (Ks**(ALPHA))*(Ls**(1.0d0-ALPHA))

        Taxagg = 0.0d0
        Tragg= 0.0d0

        do ix = 1,nx

            xnow = xgrid(ix)

            do ik = 1,nk

                anow = kgrid(ik)

                if (ndist(ik,ix)>0.0d0) then
                    earns = w*xnow*HBAR
                else
                    earns = 0.0d0
                end if

                call taxfunc(earns,anow,r,Yagg,kappa1,kappa2,hsvflag,taxtemp)
                call transfers(xnow,anow,r,w,ndist(ik,ix),Yagg,Trscale,Transprog1,Transprog2,T0,Tr)
                Taxagg = Taxagg + taxtemp*mumat(ik,ix)
                Tragg = Tragg + Tr*mumat(ik,ix)

            end do

        end do

        !Taxagg = taul*w*Ls
        KY = Ks/Ys
        TY = Taxagg/Ys
        TrY = Tragg/Ys ! Transfer/GDP ratio
        Govt= Taxagg-Tragg ! Total tax revenue - Total Transfers, Government expenditure is like a residual; should be positive

        ! we minimize K/L deviation
        distancedamp = log(Ks/Ls) - log(Kagg/Lagg)
        
        ! 20191209: if it converges too fast, then K may be wrong (affected by initial guess)
        if (iterationout > 3) then
            distanceout = abs(distancedamp)
        end if
        

		write(*,*) " "
		write(*,"('  ======> pct(Ks/Ls-Kagg/Lagg) = ', F10.8)") distancedamp
		write(*,*) " "

		call calcdiststat(xgrid,kgrid,ndist,mumat,muk,w,r,HBAR,Trscale,Transprog1,Transprog2,T0,EPratio,Yagg,Tragg, &
			Giniwage,Giniearns,Giniwealth,ShareW51,ShareW52,ShareW53,ShareW54,ShareW55, &
			EmpW51,EmpW52,EmpW53,EmpW54,EmpW55,TrInc51,TrInc52,TrInc53,TrInc54,TrInc55,TrIncInc51,TrIncInc52,TrIncInc53,TrIncInc54,TrIncInc55,TrW51,TrW52,TrW53,TrW54,TrW55,negW)
			
		TrInc5(1) = TrInc51
		TrInc5(2) = TrInc52
		TrInc5(3) = TrInc53
		TrInc5(4) = TrInc54
		TrInc5(5) = TrInc55
		TrW5(1) = TrW51
		TrW5(2) = TrW52
		TrW5(3) = TrW53
		TrW5(4) = TrW54
		TrW5(5) = TrW55
		EmpW5(1) = EmpW51
		EmpW5(2) = EmpW52
		EmpW5(3) = EmpW53
		EmpW5(4) = EmpW54
		EmpW5(5) = EmpW55

		if (diagflag==1) then
			write(*,"('  Aggregated statistics')")
			write(*,"('   L   = ', F8.5, '  Ls = ', F8.5, ' K    = ', F8.5, ' Ks    =', F8.5)") Lagg, Ls, Kagg, Ks
			write(*,"('   EP  = ', F8.5, ' K/Y = ', F8.5, ' Govt = ', F8.5)") EPratio, KY, Govt
	        write(*,"('   Tax = ', F8.5, '  Tr = ', F8.5, ' Tax/Y = ', F8.5, ' Tr/Y =', F8.5)") Taxagg, Tragg, Taxagg/Ys, Tragg/Ys
			write(*,*) " "
			write(*,"('  Disaggregated statistics')")
			write(*,"('   Giniwage = ', F8.5, ' Giniwealth = ', F8.5, ' Frac with neg wealth = ', F8.5)") Giniwage, Giniwealth, negW
	        write(*,"('   ShareW5-1st = ', F8.3, ' 2nd = ', F8.3, ' 3rd = ', F8.3, ' 4th = ', F8.3, ' 5th = ', F8.3)") ShareW51, ShareW52, ShareW53, ShareW54, ShareW55
	        write(*,"('   ErateW5-1st = ', F8.5, ' 2nd = ', F8.5, ' 3rd = ', F8.5, ' 4th = ', F8.5, ' 5th = ', F8.5)") EmpW51, EmpW52, EmpW53, EmpW54, EmpW55
            write(*,"('   TrW5-1st    = ', F8.3, ' 2nd = ', F8.3, ' 3rd = ', F8.3, ' 4th = ', F8.3, ' 5th = ', F8.3)") TrW51, TrW52, TrW53, TrW54, TrW55
	        write(*,"('   TrInc5-1st  = ', F8.3, ' 2nd = ', F8.3, ' 3rd = ', F8.3, ' 4th = ', F8.3, ' 5th = ', F8.3)") TrInc51, TrInc52, TrInc53, TrInc54, TrInc55
		end if

        r = (1.0d0 - (1.0d0-damp)*distancedamp)*r
        Lagg = Ls

        iterationout = iterationout + 1
		if (iterationout > 50 .or. r < 0.0d0) then
			error = 1
			exit
		end if

    end do
    
    ! Calculate cmatw and cmatn
    cmatw = 0.0d0
    cmatn = 0.0d0
    do ix = 1,nx
		xnow = xgrid(ix)
		! compute conditional expected value functions on grid points
		EV = 0.0d0
		do jx = 1,nx
			EV = EV + pxij(ix,jx)*reshape(Vmatss(:,jx),(/na/))
		end do

		! fit spline
		if (linflag==0) cfa = spfit(invTa,EV,ra,agrid)

		do ik = 1,nk

			anow = kgrid(ik)
            
            call calcwnval(xnow,anow,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,agrid,cfa,EV,tol,linflag,0,hsvflag,awp,anp,TW,TN,cw,cn)
            
            cmatw(ik,ix) = cw
            cmatn(ik,ix) = cn
			
		end do

	end do
    
    Vmat= Vmatss 
    
    

	print *, " "
	if (calcma==0) print *, " NOTE: minasset is calculated by ascending order search"
    do ix = 1,nx
        write(*,"('  minasset for xgrid ', I4, '   is = ', F10.5)") ix, minasset(ix)
    end do
	call system_clock(cto2, cro)
	eptimeo = dble(cto2-cto1)/cro
	if (diagflag==1) write(*,"('  Total Elasped time = ', F10.5)") eptimeo
    
    stdlogwage=0.0d0
    stdlogearn=0.0d0
    rhoxest=0.0d0



end subroutine calcss


subroutine readss(ALPHA,agrid,kgrid,xgrid,pxij,xss,mumat,ndist,muk,Kss,Lss,Yss,ALOW)


	real(8), intent(in) :: ALPHA
	real(8), intent(out) :: agrid(:), kgrid(:), xgrid(:), pxij(:,:), xss(:), mumat(:,:), ndist(:,:), muk(:), Kss, Lss, Yss, ALOW
	integer ix, ia, ik, jx, nx, na, nk


	nx = size(xgrid,1)
	na = size(agrid,1)
	nk = size(kgrid,1)

	open(22, file="xss.txt")
    open(23, file="agrid.txt")
    open(24, file="xgrid.txt")
    open(25, file="kgrid.txt")
    open(26, file="mumatss.txt")
    open(31, file="pxij.txt")
    open(33, file="ndist.txt")

    do ia = 1,na
        read(23, *) agrid(ia)
    end do

    do ix = 1,nx
        read(22, *) xss(ix)
        read(24, *) xgrid(ix)
    end do

    do ik = 1,nk
        read(25, *) kgrid(ik)
    end do

    do jx = 1,nx
        do ix = 1,nx
            read(31, *) pxij(ix,jx)
        end do
    end do

    do ix = 1,nx
        do ik = 1,nk
            read(26, *) mumat(ik,ix)
            read(33, *) ndist(ik,ix)
        end do
    end do

    close(22)
    close(23)
    close(24)
    close(25)
    close(26)
    close(31)
    close(33)

    ALOW = 0.0d0

    Kss = 0.0d0
    muk = sum(mumat,2)
    do ik = 1,nk
        Kss = Kss + muk(ik)*kgrid(ik)
    end do

    Lss = 0.0d0
    do ix = 1,nx
        
        Lss = Lss + sum(mumat(:,ix)*ndist(:,ix)*xgrid(ix),1)
    end do

    ! EPratio = sum(sum(mumat*ndist/HBAR,1),1)
    Yss = (Kss**(ALPHA))*(Lss**(1.0d0-ALPHA))



end subroutine readss


function bisectma(agrid,cfa,EV,Wvalvec,Nvalvec,xnow,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,tol,ascend,linflag,hsvflag) result(ma0)


	real(8), intent(in) :: agrid(:), cfa(:,:), EV(:), Wvalvec(:), Nvalvec(:), xnow, r, w, Yagg, &
		HBAR, Trscale, Transprog1,Transprog2, T0, B0, kappa1, kappa2, ALOW, tol
	integer, intent(in) :: ascend, linflag, hsvflag
	real(8) ma0, malow, mahigh, WNdiffL, WNdiffH, WNdiff0, awp, anp, TW, TN, distance
    Real(8) :: epsilonasset, cw, cn
	integer ia, na, iteration


	na = size(agrid,1)

	if (ascend) then
		! ascending order
		! NOTE: find minimum ia so that W(ia)<N(ia)
		do ia = 1,na
		    if ((Wvalvec(ia)-Nvalvec(ia)) < 0.0d0) exit
		end do

	else
		! descending order
		! NOTE: find minimum ia so that W(ia)>N(ia)
		do ia = na,1,-1
		    if ((Wvalvec(ia)-Nvalvec(ia)) > 0.0d0) exit
		end do
		ia = ia + 1

    end if

    epsilonasset = 1d-8
    call calcwnval(xnow,epsilonasset,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,agrid,cfa,EV,tol,linflag,0,hsvflag,awp,anp,TW,TN,cw,cn)

	if ((ia == 1).or.(TW-Tn < 0.0d0)) then

	    ma0 = agrid(1)

	elseif (ia > na) then

	    ma0 = agrid(na)

	else

	    malow = agrid(ia-1)
	    WNdiffL = Wvalvec(ia-1) - Nvalvec(ia-1)
	    mahigh = agrid(ia)
	    WNdiffH = Wvalvec(ia) - Nvalvec(ia)

	    if (WNdiffL*WNdiffH > 0.0d0) then

		    print *, "  Bisection prerequisite violated!"
	        write(*,"('  ia-1 ', I4, '   ia ', I4)") ia-1, ia

		else

			! bisection
			distance = 1d+4
	        iteration = 0

			! do while (distance > tol/100.d0.0d0) ! NOTE 180507 old calibration does not converge when tol*10.0d0
	        do while (distance > tol*10.0d0)

	            ma0 = (malow+mahigh)/2.0d0
	            ! anow = ma0

				call calcwnval(xnow,ma0,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,agrid,cfa,EV,tol,linflag,0,hsvflag,awp,anp,TW,TN,cw,cn)

	            WNdiff0 = TW-TN

	            ! f(x0)*f(xl)
	            if (WNdiff0*WNdiffL > 0.0d0) then
	                malow = ma0
	            else
	                mahigh = ma0
	            end if

	            distance = mahigh-malow
	            iteration = iteration + 1
	            ! diagnosis
	            !write(*,"('  bisection ', I4, '  ahigh-alow = ', F10.5)") iteration, distance

	        end do ! while loop for bisection

	    end if

	end if


end function bisectma





           
subroutine calcwnval(xnow,anow,r,w,Yagg,HBAR,Trscale,Transprog1,Transprog2,T0,B0,kappa1,kappa2,ALOW,agrid,cfa,EV,tol,linflag,howard,hsvflag,awp,anp,TW,TN,cw,cn)
! NOTE calculating the next period's asset and current period's value conditioned on labor choice, W or N.  Taking individual state (a,x) and prices (r,w) as given.
! NOTE 20200112: atilde is individual specific

	real(8), intent(in) :: xnow, anow, r, w, Yagg, HBAR, Trscale, Transprog1, Transprog2, T0, B0, kappa1, kappa2, ALOW
	real(8), intent(in) :: agrid(:), cfa(:,:), EV(:), tol
	integer, intent(in) :: linflag, howard, hsvflag
	real(8), intent(inout) :: awp, anp
	real(8), intent(out) :: TW, TN, cw, cn
	real(8) Trw, kwhigh, Trn, knhigh, taxw, taxn, atilde


    ! value of work
	call transfers(xnow,anow,r,w,HBAR,Yagg,Trscale,Transprog1,Transprog2,T0,Trw)
    call taxfunc(w*xnow*HBAR,anow,r,Yagg,kappa1,kappa2,hsvflag,taxw)
	kwhigh = w*xnow*HBAR + (1.0d0+r)*anow - taxw + Trw
	if (w*xnow*HBAR + (1.0d0+r)*anow - taxw + Trw - alow <= 0.0d0) then
		write(*,"('  max consumption (when work) is negative', F10.2)") kwhigh
    end if

	!if (howard==0) call gss(ALOW,kwhigh,awp,tol/100.d0,1,linflag,anow,xnow,agrid,cfa,EV,w,r,taxw,Trw,B0,Hbar,kappa2)
    if (howard==0) call gssout(ALOW,kwhigh,awp,tol/100.d0,1,linflag,anow,xnow,agrid,cfa,EV,w,r,taxw,Trw,B0,Hbar,kappa2)
	TW = -objneg_w(awp,anow,xnow,agrid,cfa,EV,w,r,taxw,Trw,B0,Hbar,kappa2,linflag)
    cw = kwhigh - awp

    
	! value of not working
    
    ! for a below atilde, not-working is not feasible (consumption negative)
    !if (Trscale == 0.0d0) then
    ! NOTE: 20200201 bug found: this should not be used
    !    atilde = (alow)/(1.0d0+r)
    !else
        ! transfer if not working
        call transfers(xnow,anow,r,w,0.0d0,Yagg,Trscale,Transprog1,Transprog2,T0,Trn)
        atilde = (alow - Trn)/(1.0d0+r)
    !end if
    
	if (anow>atilde) then
        call taxfunc(0.0d0,anow,r,Yagg,kappa1,kappa2,hsvflag,taxn)
		call transfers(xnow,anow,r,w,0.0d0,Yagg,Trscale,Transprog1,Transprog2,T0,Trn)
		knhigh = (1.0d0+r)*anow - taxn + Trn
		!if (howard==0) call gss(ALOW,knhigh,anp,tol/100.d0,0,linflag,anow,xnow,agrid,cfa,EV,w,r,taxn,Trn,B0,Hbar,kappa2)
        if (howard==0) call gssout(ALOW,knhigh,anp,tol/100.d0,0,linflag,anow,xnow,agrid,cfa,EV,w,r,taxn,Trn,B0,Hbar,kappa2)
		TN = -objneg_n(anp,anow,agrid,cfa,EV,r,taxn,Trn,linflag)
        cn = knhigh - anp
	else
		anp = alow        
		TN = -1d+20
        cn = 0.0d0
    end if
    
    


end subroutine calcwnval

!

subroutine gssout(xmin,xmax,x,critg,flag,linflag,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2)
! Note: 20200122 GSS excluding regions with non-concave expected value function
! Approach: come down from above and break it half at convex point (Assumption: expected value function looks like envelope of two concave functions)

	real(8), intent(in) :: xmin, xmax, critg, anow, xnow, w, r, Tax, Tr, B0, Hbar, kappa2
    real(8), intent(in) :: agrid(:)
    real(8), intent(in) :: cfa(:,:), EV(:)
    ! for linear interpolation
    !real(8), intent(in) :: cfa(:)
    integer, intent(in) :: flag, linflag
	real(8), intent(out) :: x
    
    real(8), allocatable :: dEV(:), ddEV(:), xminvec(:), xmaxvec(:), xoptvec(:), fval(:)    
    integer ia, na, nreg, counttemp, indexc, ir, iamax, indopt
    
    na = size(agrid,1)
    nreg = 5
    
    allocate(dEV(na-1),ddEV(na-1))
    
    do ia = 1,na-1
        dEV(ia) = (EV(ia+1)-EV(ia))/(agrid(ia+1)-agrid(ia))
    end do
    
    ! Note: ddEV cannot be checked for ia =1
    ddEV(1) = -1.0d0
    do ia = 2,na-1
        ddEV(ia) = dEV(ia)-dEV(ia-1)
    end do
    
    ! check
    do ia = na-1,2,-1
        if (ddEV(ia) > 0.0d0) exit
    end do
    
    !if ((ia==2)) then
        ! okay
        call gss(xmin,xmax,x,critg,flag,linflag,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2)    
        
   ! else        
   !     allocate(xoptvec(nreg),fval(nreg),xminvec(nreg+1))
   !     if (xmax < agrid(ia)) then
   !         xminvec = linspace(xmin,xmax,nreg+1)
   !     else
   !         xminvec(1:nreg) = linspace(xmin,agrid(ia),nreg)
   !         xminvec(nreg+1) = xmax
   !     end if
   !     
   !     do ir = 1,nreg
   !         call gss(xminvec(ir),xminvec(ir+1),xoptvec(ir),critg,flag,linflag,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2)
   !     end do
   !     
   !     do ir = 1,nreg
   !         
			!if (flag==1) then
			!	fval(ir) = objneg_w(xoptvec(ir),anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2,linflag)							
			!else
			!	fval(ir) = objneg_n(xoptvec(ir),anow,agrid,cfa,EV,r,Tax,Tr,linflag)							
   !         end if
   !         
   !     end do
   !     indopt = minloc(fval,1)
   !     x = xoptvec(indopt)
   !     
   ! end if
    
     

end subroutine gssout



subroutine gss(xmin,xmax,x0,critg,flag,linflag,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2)


	real(8), intent(in) :: xmin, xmax, critg, anow, xnow, w, r, Tax, Tr, B0, Hbar, kappa2
    real(8), intent(in) :: agrid(:)
    real(8), intent(in) :: cfa(:,:), EV(:)
    ! for linear interpolation
    !real(8), intent(in) :: cfa(:)
    integer, intent(in) :: flag, linflag
	real(8), intent(out) :: x0

	real(8) rg, a, b, c, d, z, fc, fd, crit, diff, fa, fb
	integer iter


	rg = (3.0d0-sqrt(5.0d0))/2.0d0

	a = xmin
	b = xmax
	c = a + rg*(b-a)
    if (flag==1) then
        fc = objneg_w(c,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2,linflag)
        fa = objneg_w(a,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2,linflag)
        fb = objneg_w(b,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,HBAR,kappa2,linflag)
    else
        fc = objneg_n(c,anow,agrid,cfa,EV,r,Tax,Tr,linflag)
        fa = objneg_n(a,anow,agrid,cfa,EV,r,Tax,Tr,linflag)
        fb = objneg_n(b,anow,agrid,cfa,EV,r,Tax,Tr,linflag)
    end if

    ! x = c

	d = a + (1.0d0-rg)*(b-a)
    if (flag==1) then
        fd = objneg_w(d,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,Hbar,kappa2,linflag)
    else
        fd = objneg_n(d,anow,agrid,cfa,EV,r,Tax,Tr,linflag)
    end if

    diff = 1d+4
	iter = 0

	do while (diff>critg)

 		if (fc>=fd) then

        	z = c + (1.0d0-rg)*(b-c)
        	a = c
        	c = d
        	fc = fd
        	d = z
            if (flag==1) then
                fd = objneg_w(d,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,Hbar,kappa2,linflag)
            else
                fd = objneg_n(d,anow,agrid,cfa,EV,r,Tax,Tr,linflag)
            end if

	    else

        	z = a + rg*(d-a)
        	b = d
        	d = c
        	fd = fc
        	c = z
            if (flag==1) then
                fc = objneg_w(c,anow,xnow,agrid,cfa,EV,w,r,Tax,Tr,B0,Hbar,kappa2,linflag)
            else
                fc = objneg_n(c,anow,agrid,cfa,EV,r,Tax,Tr,linflag)
            end if

    	end if

	    diff = d-c
    	iter = iter+1

        ! diagnosis
!        write(*,"('  iteration ', I4, '  New x = ', F10.5)") iter, diff

	end do


    If (fa==max(fa,fb,fc)) then
        x0 = a
    else if (fb == max(fa,fb,fc)) then
        x0 = c
    else
	    x0 = (c+d)/2.0d0
    end if


end subroutine gss


function objneg_w(ap,anow,xnow,agrid,cfa,EVa,w,r,Tax,Tr,B0,HBAR,kappa2,linflag) result(f)


    real(8), intent(in) :: ap, anow, xnow, w, r, Tax, Tr, B0, HBAR, kappa2
    real(8), intent(in) :: agrid(:)
    real(8), intent(in) :: cfa(:,:), EVa(:)
	integer, intent(in) :: linflag
    real(8) cnow, ev, edv, ed2v, f
	integer ra

	ra = size(agrid,1)-2

    cnow = w*xnow*HBAR + (1.0d0+r)*anow - Tax + Tr - ap

	if (linflag==1) then
		call lineva1(agrid,EVa,ap,EV)
	else
    	call speva(cfa,ap,ra,agrid,EV,EDV,ED2V)
	end if

	f = log(cnow) - B0 + beta*EV
    f = -f


end function objneg_w


function objneg_n(ap,anow,agrid,cfa,EVa,r,Tax,Tr,linflag) result(f)


    real(8), intent(in) :: ap, anow, r, Tax, Tr
    real(8), intent(in) :: agrid(:)
    real(8), intent(in) :: cfa(:,:), EVa(:)
	integer, intent(in) :: linflag
    real(8) cnow, ev, edv, ed2v, f
	integer ra

	ra = size(agrid,1)-2

    cnow = (1.0d0+r)*anow - Tax + Tr - ap

	if (linflag==1) then
		call lineva1(agrid,EVa,ap,EV)
	else
    	call speva(cfa,ap,ra,agrid,EV,EDV,ED2V)
	end if

	f = log(cnow) + beta*EV
    f = -f


end function objneg_n


subroutine calcdiststat(xgrid,kgrid,ndist,mumat,muk,w,r,HBAR,Trscale,Transprog1,Transprog2,T0,EPratio,Yagg,Tragg, &
	Giniwage,Giniearns,Giniwealth,ShareW51,ShareW52,ShareW53,ShareW54,ShareW55, &
	EmpW51,EmpW52,EmpW53,EmpW54,EmpW55,TrInc51,TrInc52,TrInc53,TrInc54,TrInc55,TrIncInc51,TrIncInc52,TrIncInc53,TrIncInc54,TrIncInc55,TrW51,TrW52,TrW53,TrW54,TrW55,negW)


	real(8), intent(in) :: xgrid(:), kgrid(:), ndist(:,:), mumat(:,:), muk(:)
	real(8), intent(in) :: w, r, HBAR, EPratio, Yagg, Tragg, Trscale, Transprog1,Transprog2, T0
	real(8), intent(out) :: Giniwage, Giniearns, Giniwealth, ShareW51, ShareW52, ShareW53, ShareW54, ShareW55, &
		EmpW51, EmpW52, EmpW53, EmpW54, EmpW55, TrInc51, TrInc52, TrInc53, TrInc54, TrInc55,TrW51,TrW52,TrW53,TrW54,TrW55, &
        TrIncInc51, TrIncInc52, TrIncInc53, TrIncInc54, TrIncInc55, negW
	integer ne, nx, nk, ie, ix, ik, ii
	real(8), allocatable :: incgrid(:), muinc(:), trgrid(:)
	real(8) W5threshold(4), cummmk, wgtik(4), SumwgtW5(5), EsumW5(5), ShareW5(5), ShareE5(5), TrsumW5(5), trans !, ShareW10(10), ShareW101
    real(8) Inc5threshold(4), SumwgtInc5(5), TrsumInc5(5), IncsumInc5(5)


	ne = size(xgrid,1)
	nk = size(kgrid,1)
	allocate(incgrid(nk*ne),muinc(nk*ne),trgrid(nk*ne))

	! distribution (maybe optional)
	call calwagegini(xgrid,ndist,mumat,w,HBAR,EPratio,Giniwage)
	call calearnsgini(xgrid,ndist,mumat,w,Giniearns)
	!call calwealthgini(kgrid,mumat,Giniwealth)
	call ginicoef(muk,kgrid,nk,5,Giniwealth,ShareW5,negW)
	! call ginicoef(muk,kgrid,nk,10,Giniwealth,ShareW10,negW)

	! ShareW101 = ShareW10(1)*100.0d0

	! Employment rate by wealth
	! calculating threshold
	W5threshold = 0         ! index
	cummmk = 0.0d0
	wgtik = 0.0d0           ! calculating division rule for threshold

	do ik = 1,nk
		cummmk = cummmk + muk(ik)
		if (cummmk >= 0.2d0 .and. W5threshold(1) == 0 ) then
			W5threshold(1) = ik
			wgtik(1) = 1.0d0 - (cummmk - 0.2d0)/(muk(ik))
		elseif (cummmk >= 0.4d0 .and. W5threshold(2) == 0 ) then
			W5threshold(2) = ik
			wgtik(2) = 1.0d0 - (cummmk - 0.4d0)/(muk(ik))
		elseif (cummmk >= 0.6d0 .and. W5threshold(3) == 0 ) then
			W5threshold(3) = ik
			wgtik(3) = 1.0d0 - (cummmk - 0.6d0)/(muk(ik))
		elseif (cummmk >= 0.8d0 .and. W5threshold(4) == 0 ) then
			W5threshold(4) = ik
			wgtik(4) = 1.0d0 - (cummmk - 0.8d0)/(muk(ik))
		end if
	end do

	SumwgtW5 = 0.0d0
	EsumW5 = 0.0d0
    TrsumW5 = 0.0d0
	ShareW5 = 0.0d0

	do ik = 1,nk
		do ie = 1,ne
            ix = ie
            ! 20180718 progressive part only
            call transfers(xgrid(ix),kgrid(ik),r,w,ndist(ik,ie),Yagg,Trscale,Transprog1,Transprog2,T0,trans)
            trans = trans - T0
            
			if (ik < W5threshold(1)) then
				SumwgtW5(1) = SumwgtW5(1) + mumat(ik,ie)
				EsumW5(1) = EsumW5(1) + (ndist(ik,ie)/hbar)*mumat(ik,ie)
				ShareW5(1) = ShareW5(1) + kgrid(ik)*mumat(ik,ie)                
                TrsumW5(1) = TrsumW5(1) + trans*mumat(ik,ie)
			elseif (ik == W5threshold(1)) then
				SumwgtW5(1) = SumwgtW5(1) + mumat(ik,ie)*wgtik(1)
				SumwgtW5(2) = SumwgtW5(2) + mumat(ik,ie)*(1.0d0-wgtik(1))
				EsumW5(1) = EsumW5(1) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*wgtik(1)
				EsumW5(2) = EsumW5(2) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*(1.0d0-wgtik(1))
				ShareW5(1) = ShareW5(1) + kgrid(ik)*mumat(ik,ie)*wgtik(1)
				ShareW5(2) = ShareW5(2) + kgrid(ik)*mumat(ik,ie)*(1.0d0-wgtik(1))
                TrsumW5(1) = TrsumW5(1) + trans*mumat(ik,ie)*wgtik(1)
                TrsumW5(2) = TrsumW5(2) + trans*mumat(ik,ie)*(1.0d0-wgtik(1))
			elseif (ik > W5threshold(1) .and. ik < W5threshold(2)) then
				SumwgtW5(2) = SumwgtW5(2) + mumat(ik,ie)
				EsumW5(2) = EsumW5(2) + (ndist(ik,ie)/hbar)*mumat(ik,ie)
				ShareW5(2) = ShareW5(2) + kgrid(ik)*mumat(ik,ie)
                TrsumW5(2) = TrsumW5(2) + trans*mumat(ik,ie)
			elseif (ik == W5threshold(2)) then
				SumwgtW5(2) = SumwgtW5(2) + mumat(ik,ie)*wgtik(2)
				SumwgtW5(3) = SumwgtW5(3) + mumat(ik,ie)*(1.0d0-wgtik(2))
				EsumW5(2) = EsumW5(2) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*wgtik(2)
				EsumW5(3) = EsumW5(3) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*(1.0d0-wgtik(2))
				ShareW5(2) = ShareW5(2) + kgrid(ik)*mumat(ik,ie)*wgtik(2)
				ShareW5(3) = ShareW5(3) + kgrid(ik)*mumat(ik,ie)*(1.0d0-wgtik(2))
                TrsumW5(2) = TrsumW5(2) + trans*mumat(ik,ie)*wgtik(2)
                TrsumW5(3) = TrsumW5(3) + trans*mumat(ik,ie)*(1.0d0-wgtik(2))
			elseif (ik > W5threshold(2) .and. ik < W5threshold(3)) then
				SumwgtW5(3) = SumwgtW5(3) + mumat(ik,ie)
				EsumW5(3) = EsumW5(3) + (ndist(ik,ie)/hbar)*mumat(ik,ie)
				ShareW5(3) = ShareW5(3) + kgrid(ik)*mumat(ik,ie)
                TrsumW5(3) = TrsumW5(3) + trans*mumat(ik,ie)
			elseif (ik == W5threshold(3)) then
				SumwgtW5(3) = SumwgtW5(3) + mumat(ik,ie)*wgtik(3)
				SumwgtW5(4) = SumwgtW5(4) + mumat(ik,ie)*(1.0d0-wgtik(3))
				EsumW5(3) = EsumW5(3) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*wgtik(3)
				EsumW5(4) = EsumW5(4) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*(1.0d0-wgtik(3))
				ShareW5(3) = ShareW5(3) + kgrid(ik)*mumat(ik,ie)*wgtik(3)
				ShareW5(4) = ShareW5(4) + kgrid(ik)*mumat(ik,ie)*(1.0d0-wgtik(3))
                TrsumW5(3) = TrsumW5(3) + trans*mumat(ik,ie)*wgtik(3)
                TrsumW5(4) = TrsumW5(4) + trans*mumat(ik,ie)*(1.0d0-wgtik(3))
			elseif (ik > W5threshold(3) .and. ik < W5threshold(4)) then
				SumwgtW5(4) = SumwgtW5(4) + mumat(ik,ie)
				EsumW5(4) = EsumW5(4) + (ndist(ik,ie)/hbar)*mumat(ik,ie)
				ShareW5(4) = ShareW5(4) + kgrid(ik)*mumat(ik,ie)
                TrsumW5(4) = TrsumW5(4) + trans*mumat(ik,ie)
			elseif (ik == W5threshold(4)) then
				SumwgtW5(4) = SumwgtW5(4) + mumat(ik,ie)*wgtik(4)
				SumwgtW5(5) = SumwgtW5(5) + mumat(ik,ie)*(1.0d0-wgtik(4))
				EsumW5(4) = EsumW5(4) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*wgtik(4)
				EsumW5(5) = EsumW5(5) + (ndist(ik,ie)/hbar)*mumat(ik,ie)*(1.0d0-wgtik(4))
				ShareW5(4) = ShareW5(4) + kgrid(ik)*mumat(ik,ie)*wgtik(4)
				ShareW5(5) = ShareW5(5) + kgrid(ik)*mumat(ik,ie)*(1.0d0-wgtik(4))
                TrsumW5(4) = TrsumW5(4) + trans*mumat(ik,ie)*wgtik(4)
                TrsumW5(5) = TrsumW5(5) + trans*mumat(ik,ie)*(1.0d0-wgtik(4))
			else
				SumwgtW5(5) = SumwgtW5(5) + mumat(ik,ie)
				EsumW5(5) = EsumW5(5) + (ndist(ik,ie)/hbar)*mumat(ik,ie)
				ShareW5(5) = ShareW5(5) + kgrid(ik)*mumat(ik,ie)
                TrsumW5(5) = TrsumW5(5) + trans*mumat(ik,ie)
			end if
		end do
	end do

	EmpW51 = EsumW5(1)/SumwgtW5(1)
	EmpW52 = EsumW5(2)/SumwgtW5(2)
	EmpW53 = EsumW5(3)/SumwgtW5(3)
	EmpW54 = EsumW5(4)/SumwgtW5(4)
	EmpW55 = EsumW5(5)/SumwgtW5(5)

	ShareW51 = 100.0d0*ShareW5(1)/sum(ShareW5)
	ShareW52 = 100.0d0*ShareW5(2)/sum(ShareW5)
	ShareW53 = 100.0d0*ShareW5(3)/sum(ShareW5)
	ShareW54 = 100.0d0*ShareW5(4)/sum(ShareW5)
	ShareW55 = 100.0d0*ShareW5(5)/sum(ShareW5)
    
    ! 20180718 progressive part only
    TrW51 = (TrsumW5(1)/SumwgtW5(1))/(Tragg-T0)
	TrW52 = (TrsumW5(2)/SumwgtW5(2))/(Tragg-T0)
	TrW53 = (TrsumW5(3)/SumwgtW5(3))/(Tragg-T0)
	TrW54 = (TrsumW5(4)/SumwgtW5(4))/(Tragg-T0)
	TrW55 = (TrsumW5(5)/SumwgtW5(5))/(Tragg-T0)

	! Transfers by income
	! construct income distribution (not sorted)
	muinc = 0.0d0
	incgrid = 0.0d0
	trgrid = 0.0d0

	do ik = 1,nk
		do ie = 1,ne
			ii = ik + (ie-1)*nk
			muinc(ii) = mumat(ik,ie)
			ix = ie
			if (kgrid(ik) > 0) then
				incgrid(ii) = w*xgrid(ix)*ndist(ik,ie) + r*kgrid(ik)
			else
				incgrid(ii) = w*xgrid(ix)*ndist(ik,ie)
            end if
            
            ! 20180718 progressive part only
			call transfers(xgrid(ix),kgrid(ik),r,w,ndist(ik,ie),Yagg,Trscale,Transprog1,Transprog2,T0,trans)
            trgrid(ii) = trans - T0
		end do
	end do

	! ordering income distirbution
	call sortdist((nk*ne), incgrid, muinc, trgrid, incgrid, muinc, trgrid)

	! calculating threshold
	Inc5threshold = 0         ! index
	cummmk = 0.0d0
	wgtik = 0.0d0           ! calculating division rule for threshold

	do ii = 1,(nk*ne)
		cummmk = cummmk + muinc(ii)
		if (cummmk >= 0.2d0 .and. Inc5threshold(1) == 0 ) then
			Inc5threshold(1) = ii
			wgtik(1) = 1.0d0 - (cummmk - 0.2d0)/(muinc(ii))
		elseif (cummmk >= 0.4d0 .and. Inc5threshold(2) == 0 ) then
			Inc5threshold(2) = ii
			wgtik(2) = 1.0d0 - (cummmk - 0.4d0)/(muinc(ii))
		elseif (cummmk >= 0.6d0 .and. Inc5threshold(3) == 0 ) then
			Inc5threshold(3) = ii
			wgtik(3) = 1.0d0 - (cummmk - 0.6d0)/(muinc(ii))
		elseif (cummmk >= 0.8d0 .and. Inc5threshold(4) == 0 ) then
			Inc5threshold(4) = ii
			wgtik(4) = 1.0d0 - (cummmk - 0.8d0)/(muinc(ii))
		end if
	end do

	SumwgtInc5 = 0.0d0
	TrsumInc5 = 0.0d0
    IncsumInc5 = 0.0d0

	do ii = 1,(nk*ne)
		if (ii < Inc5threshold(1)) then
			SumwgtInc5(1) = SumwgtInc5(1) + muinc(ii)
			TrsumInc5(1) = TrsumInc5(1) + muinc(ii)*trgrid(ii)
            IncsumInc5(1) = IncsumInc5(1) + muinc(ii)*incgrid(ii)
		elseif (ii == Inc5threshold(1)) then
			SumwgtInc5(1) = SumwgtInc5(1) + muinc(ii)*wgtik(1)
			SumwgtInc5(2) = SumwgtInc5(2) + muinc(ii)*(1.0d0-wgtik(1))
			TrsumInc5(1) = TrsumInc5(1) + muinc(ii)*trgrid(ii)*wgtik(1)            
			TrsumInc5(2) = TrsumInc5(2) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(1))
            IncsumInc5(1) = IncsumInc5(1) + muinc(ii)*incgrid(ii)*wgtik(1)            
            IncsumInc5(2) = IncsumInc5(2) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(1))
		elseif (ii > Inc5threshold(1) .and. ii < Inc5threshold(2)) then
			SumwgtInc5(2) = SumwgtInc5(2) + muinc(ii)
			TrsumInc5(2) = TrsumInc5(2) + muinc(ii)*trgrid(ii)
            IncsumInc5(2) = IncsumInc5(2) + muinc(ii)*incgrid(ii)
		elseif (ii == Inc5threshold(2)) then
			SumwgtInc5(2) = SumwgtInc5(2) + muinc(ii)*wgtik(2)
			SumwgtInc5(3) = SumwgtInc5(3) + muinc(ii)*(1.0d0-wgtik(2))
			TrsumInc5(2) = TrsumInc5(2) + muinc(ii)*trgrid(ii)*wgtik(2)
			TrsumInc5(3) = TrsumInc5(3) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(2))
            IncsumInc5(2) = IncsumInc5(2) + muinc(ii)*incgrid(ii)*wgtik(2)            
            IncsumInc5(3) = IncsumInc5(3) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(2))
		elseif (ii > Inc5threshold(2) .and. ii < Inc5threshold(3)) then
			SumwgtInc5(3) = SumwgtInc5(3) + muinc(ii)
			TrsumInc5(3) = TrsumInc5(3) + muinc(ii)*trgrid(ii)
            IncsumInc5(3) = IncsumInc5(3) + muinc(ii)*incgrid(ii)
		elseif (ii == Inc5threshold(3)) then
			SumwgtInc5(3) = SumwgtInc5(3) + muinc(ii)*wgtik(3)
			SumwgtInc5(4) = SumwgtInc5(4) + muinc(ii)*(1.0d0-wgtik(3))
			TrsumInc5(3) = TrsumInc5(3) + muinc(ii)*trgrid(ii)*wgtik(3)
			TrsumInc5(4) = TrsumInc5(4) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(3))
            IncsumInc5(3) = IncsumInc5(3) + muinc(ii)*incgrid(ii)*wgtik(3)            
            IncsumInc5(4) = IncsumInc5(4) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(3))
		elseif (ii > Inc5threshold(3) .and. ii < Inc5threshold(4)) then
			SumwgtInc5(4) = SumwgtInc5(4) + muinc(ii)
			TrsumInc5(4) = TrsumInc5(4) + muinc(ii)*trgrid(ii)
            IncsumInc5(4) = IncsumInc5(4) + muinc(ii)*incgrid(ii)
		elseif (ii == Inc5threshold(4)) then
			SumwgtInc5(4) = SumwgtInc5(4) + muinc(ii)*wgtik(4)
			SumwgtInc5(5) = SumwgtInc5(5) + muinc(ii)*(1.0d0-wgtik(4))
			TrsumInc5(4) = TrsumInc5(4) + muinc(ii)*trgrid(ii)*wgtik(4)
			TrsumInc5(5) = TrsumInc5(5) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(4))
            IncsumInc5(4) = IncsumInc5(4) + muinc(ii)*incgrid(ii)*wgtik(4)            
            IncsumInc5(5) = IncsumInc5(5) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(4))
		else
			SumwgtInc5(5) = SumwgtInc5(5) + muinc(ii)
			TrsumInc5(5) = TrsumInc5(5) + muinc(ii)*trgrid(ii)
            IncsumInc5(5) = IncsumInc5(5) + muinc(ii)*incgrid(ii)
		end if
    end do
    
    ! 20180718 progressive part only
	TrInc51 = (TrsumInc5(1)/SumwgtInc5(1))/(Tragg-T0)
	TrInc52 = (TrsumInc5(2)/SumwgtInc5(2))/(Tragg-T0)
	TrInc53 = (TrsumInc5(3)/SumwgtInc5(3))/(Tragg-T0)
	TrInc54 = (TrsumInc5(4)/SumwgtInc5(4))/(Tragg-T0)
	TrInc55 = (TrsumInc5(5)/SumwgtInc5(5))/(Tragg-T0)
    
    TrIncInc51 = (TrsumInc5(1)/IncsumInc5(1))
	TrIncInc52 = (TrsumInc5(2)/IncsumInc5(2))
	TrIncInc53 = (TrsumInc5(3)/IncsumInc5(3))
	TrIncInc54 = (TrsumInc5(4)/IncsumInc5(4))
	TrIncInc55 = (TrsumInc5(5)/IncsumInc5(5))

end subroutine calcdiststat


!subroutine calcdiststat(xgrid,kgrid,ndist,mumat,muk,w,r,HBAR,Trscale,Transprog1,Transprog2,T0,EPratio,Yagg,Tragg, &
!	Giniwage,Giniearns,Giniwealth,ShareW51,ShareW52,ShareW53,ShareW54,ShareW55, &
!	EmpW51,EmpW52,EmpW53,EmpW54,EmpW55,TrInc51,TrInc52,TrInc53,TrInc54,TrInc55,TrIncInc51,TrIncInc52,TrIncInc53,TrIncInc54,TrIncInc55,TrW51,TrW52,TrW53,TrW54,TrW55,negW)
!
!
!	real(8), intent(in) :: xgrid(:), kgrid(:), ndist(:,:), mumat(:,:), muk(:)
!	real(8), intent(in) :: w, r, HBAR, EPratio, Yagg, Tragg, Trscale, Transprog1,Transprog2, T0
!	real(8), intent(out) :: Giniwage, Giniearns, Giniwealth, ShareW51, ShareW52, ShareW53, ShareW54, ShareW55, &
!		EmpW51, EmpW52, EmpW53, EmpW54, EmpW55, TrInc51, TrInc52, TrInc53, TrInc54, TrInc55,TrW51,TrW52,TrW53,TrW54,TrW55, &
!        TrIncInc51, TrIncInc52, TrIncInc53, TrIncInc54, TrIncInc55, negW
!	integer nx, nk, ix, ik, ii
!	real(8), allocatable :: incgrid(:), muinc(:), trgrid(:)
!	real(8) W5threshold(4), cummmk, wgtik(4), SumwgtW5(5), EsumW5(5), ShareW5(5), ShareE5(5), TrsumW5(5), trans !, ShareW10(10), ShareW101
!    real(8) Inc5threshold(4), SumwgtInc5(5), TrsumInc5(5), IncsumInc5(5)
!
!
!	nk = size(kgrid,1)
!    nx = size(xgrid,1)
!	allocate(incgrid(nk),muinc(nk),trgrid(nk))
!
!	! distribution (maybe optional)
!	call calwagegini(xgrid,ndist,mumat,w,HBAR,EPratio,Giniwage)
!	call calearnsgini(xgrid,ndist,mumat,w,Giniearns)
!	!call calwealthgini(kgrid,mumat,Giniwealth)
!	call ginicoef(muk,kgrid,nk,5,Giniwealth,ShareW5,negW)
!	! call ginicoef(muk,kgrid,nk,10,Giniwealth,ShareW10,negW)
!
!	! ShareW101 = ShareW10(1)*100.0d0
!
!	! Employment rate by wealth
!	! calculating threshold
!	W5threshold = 0         ! index
!	cummmk = 0.0d0
!	wgtik = 0.0d0           ! calculating division rule for threshold
!
!	do ik = 1,nk
!		cummmk = cummmk + muk(ik)
!		if (cummmk >= 0.2d0 .and. W5threshold(1) == 0 ) then
!			W5threshold(1) = ik
!			wgtik(1) = 1.0d0 - (cummmk - 0.2d0)/(muk(ik))
!		elseif (cummmk >= 0.4d0 .and. W5threshold(2) == 0 ) then
!			W5threshold(2) = ik
!			wgtik(2) = 1.0d0 - (cummmk - 0.4d0)/(muk(ik))
!		elseif (cummmk >= 0.6d0 .and. W5threshold(3) == 0 ) then
!			W5threshold(3) = ik
!			wgtik(3) = 1.0d0 - (cummmk - 0.6d0)/(muk(ik))
!		elseif (cummmk >= 0.8d0 .and. W5threshold(4) == 0 ) then
!			W5threshold(4) = ik
!			wgtik(4) = 1.0d0 - (cummmk - 0.8d0)/(muk(ik))
!		end if
!	end do
!
!	SumwgtW5 = 0.0d0
!	EsumW5 = 0.0d0
!    TrsumW5 = 0.0d0
!	ShareW5 = 0.0d0
!
!	do ik = 1,nk
!		do ix = 1,nx            
!            ! 20180718 progressive part only
!            call transfers(xgrid(ix),kgrid(ik),r,w,ndist(ik,ix),Yagg,Trscale,Transprog1,Transprog2,T0,trans)
!            trans = trans - T0
!
!			if (ik < W5threshold(1)) then
!				SumwgtW5(1) = SumwgtW5(1) + mumat(ik,ix)
!				EsumW5(1) = EsumW5(1) + (ndist(ik,ix)/hbar)*mumat(ik,ix)
!				ShareW5(1) = ShareW5(1) + kgrid(ik)*mumat(ik,ix)
!                TrsumW5(1) = TrsumW5(1) + trans*mumat(ik,ix)
!			elseif (ik == W5threshold(1)) then
!				SumwgtW5(1) = SumwgtW5(1) + mumat(ik,ix)*wgtik(1)
!				SumwgtW5(2) = SumwgtW5(2) + mumat(ik,ix)*(1.0d0-wgtik(1))
!				EsumW5(1) = EsumW5(1) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*wgtik(1)
!				EsumW5(2) = EsumW5(2) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*(1.0d0-wgtik(1))
!				ShareW5(1) = ShareW5(1) + kgrid(ik)*mumat(ik,ix)*wgtik(1)
!				ShareW5(2) = ShareW5(2) + kgrid(ik)*mumat(ik,ix)*(1.0d0-wgtik(1))
!                TrsumW5(1) = TrsumW5(1) + trans*mumat(ik,ix)*wgtik(1)
!                TrsumW5(2) = TrsumW5(2) + trans*mumat(ik,ix)*(1.0d0-wgtik(1))
!			elseif (ik > W5threshold(1) .and. ik < W5threshold(2)) then
!				SumwgtW5(2) = SumwgtW5(2) + mumat(ik,ix)
!				EsumW5(2) = EsumW5(2) + (ndist(ik,ix)/hbar)*mumat(ik,ix)
!				ShareW5(2) = ShareW5(2) + kgrid(ik)*mumat(ik,ix)
!                TrsumW5(2) = TrsumW5(2) + trans*mumat(ik,ix)
!			elseif (ik == W5threshold(2)) then
!				SumwgtW5(2) = SumwgtW5(2) + mumat(ik,ix)*wgtik(2)
!				SumwgtW5(3) = SumwgtW5(3) + mumat(ik,ix)*(1.0d0-wgtik(2))
!				EsumW5(2) = EsumW5(2) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*wgtik(2)
!				EsumW5(3) = EsumW5(3) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*(1.0d0-wgtik(2))
!				ShareW5(2) = ShareW5(2) + kgrid(ik)*mumat(ik,ix)*wgtik(2)
!				ShareW5(3) = ShareW5(3) + kgrid(ik)*mumat(ik,ix)*(1.0d0-wgtik(2))
!                TrsumW5(2) = TrsumW5(2) + trans*mumat(ik,ix)*wgtik(2)
!                TrsumW5(3) = TrsumW5(3) + trans*mumat(ik,ix)*(1.0d0-wgtik(2))
!			elseif (ik > W5threshold(2) .and. ik < W5threshold(3)) then
!				SumwgtW5(3) = SumwgtW5(3) + mumat(ik,ix)
!				EsumW5(3) = EsumW5(3) + (ndist(ik,ix)/hbar)*mumat(ik,ix)
!				ShareW5(3) = ShareW5(3) + kgrid(ik)*mumat(ik,ix)
!                TrsumW5(3) = TrsumW5(3) + trans*mumat(ik,ix)
!			elseif (ik == W5threshold(3)) then
!				SumwgtW5(3) = SumwgtW5(3) + mumat(ik,ix)*wgtik(3)
!				SumwgtW5(4) = SumwgtW5(4) + mumat(ik,ix)*(1.0d0-wgtik(3))
!				EsumW5(3) = EsumW5(3) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*wgtik(3)
!				EsumW5(4) = EsumW5(4) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*(1.0d0-wgtik(3))
!				ShareW5(3) = ShareW5(3) + kgrid(ik)*mumat(ik,ix)*wgtik(3)
!				ShareW5(4) = ShareW5(4) + kgrid(ik)*mumat(ik,ix)*(1.0d0-wgtik(3))
!                TrsumW5(3) = TrsumW5(3) + trans*mumat(ik,ix)*wgtik(3)
!                TrsumW5(4) = TrsumW5(4) + trans*mumat(ik,ix)*(1.0d0-wgtik(3))
!			elseif (ik > W5threshold(3) .and. ik < W5threshold(4)) then
!				SumwgtW5(4) = SumwgtW5(4) + mumat(ik,ix)
!				EsumW5(4) = EsumW5(4) + (ndist(ik,ix)/hbar)*mumat(ik,ix)
!				ShareW5(4) = ShareW5(4) + kgrid(ik)*mumat(ik,ix)
!                TrsumW5(4) = TrsumW5(4) + trans*mumat(ik,ix)
!			elseif (ik == W5threshold(4)) then
!				SumwgtW5(4) = SumwgtW5(4) + mumat(ik,ix)*wgtik(4)
!				SumwgtW5(5) = SumwgtW5(5) + mumat(ik,ix)*(1.0d0-wgtik(4))
!				EsumW5(4) = EsumW5(4) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*wgtik(4)
!				EsumW5(5) = EsumW5(5) + (ndist(ik,ix)/hbar)*mumat(ik,ix)*(1.0d0-wgtik(4))
!				ShareW5(4) = ShareW5(4) + kgrid(ik)*mumat(ik,ix)*wgtik(4)
!				ShareW5(5) = ShareW5(5) + kgrid(ik)*mumat(ik,ix)*(1.0d0-wgtik(4))
!                TrsumW5(4) = TrsumW5(4) + trans*mumat(ik,ix)*wgtik(4)
!                TrsumW5(5) = TrsumW5(5) + trans*mumat(ik,ix)*(1.0d0-wgtik(4))
!			else
!				SumwgtW5(5) = SumwgtW5(5) + mumat(ik,ix)
!				EsumW5(5) = EsumW5(5) + (ndist(ik,ix)/hbar)*mumat(ik,ix)
!				ShareW5(5) = ShareW5(5) + kgrid(ik)*mumat(ik,ix)
!                TrsumW5(5) = TrsumW5(5) + trans*mumat(ik,ix)
!			end if
!		end do
!	end do
!
!	EmpW51 = EsumW5(1)/SumwgtW5(1)
!	EmpW52 = EsumW5(2)/SumwgtW5(2)
!	EmpW53 = EsumW5(3)/SumwgtW5(3)
!	EmpW54 = EsumW5(4)/SumwgtW5(4)
!	EmpW55 = EsumW5(5)/SumwgtW5(5)
!
!	ShareW51 = 100.0d0*ShareW5(1)/sum(ShareW5)
!	ShareW52 = 100.0d0*ShareW5(2)/sum(ShareW5)
!	ShareW53 = 100.0d0*ShareW5(3)/sum(ShareW5)
!	ShareW54 = 100.0d0*ShareW5(4)/sum(ShareW5)
!	ShareW55 = 100.0d0*ShareW5(5)/sum(ShareW5)
!
!    ! 20180718 progressive part only
!    TrW51 = (TrsumW5(1)/SumwgtW5(1))/(Tragg-T0)
!	TrW52 = (TrsumW5(2)/SumwgtW5(2))/(Tragg-T0)
!	TrW53 = (TrsumW5(3)/SumwgtW5(3))/(Tragg-T0)
!	TrW54 = (TrsumW5(4)/SumwgtW5(4))/(Tragg-T0)
!	TrW55 = (TrsumW5(5)/SumwgtW5(5))/(Tragg-T0)
!
!	! Transfers by income
!	! construct income distribution (not sorted)
!	muinc = 0.0d0
!	incgrid = 0.0d0
!	trgrid = 0.0d0
!
!	do ik = 1,nk
!		do ix = 1,nx
!			ii = ik + (ix-1)*nk
!			muinc(ii) = mumat(ik,ix)
!			
!			if (kgrid(ik) > 0) then
!				incgrid(ii) = w*xgrid(ix)*ndist(ik,ix) + r*kgrid(ik)
!			else
!				incgrid(ii) = w*xgrid(ix)*ndist(ik,ix)
!            end if
!
!            ! 20180718 progressive part only
!			call transfers(xgrid(ix),kgrid(ik),r,w,ndist(ik,ix),Yagg,Trscale,Transprog1,Transprog2,T0,trans)
!            trgrid(ii) = trans - T0
!		end do
!	end do
!
!	! ordering income distirbution
!	call sortdist((nk*nx), incgrid, muinc, trgrid, incgrid, muinc, trgrid)
!
!	! calculating threshold
!	Inc5threshold = 0         ! index
!	cummmk = 0.0d0
!	wgtik = 0.0d0           ! calculating division rule for threshold
!
!	do ii = 1,(nk*nx)
!		cummmk = cummmk + muinc(ii)
!		if (cummmk >= 0.2d0 .and. Inc5threshold(1) == 0 ) then
!			Inc5threshold(1) = ii
!			wgtik(1) = 1.0d0 - (cummmk - 0.2d0)/(muinc(ii))
!		elseif (cummmk >= 0.4d0 .and. Inc5threshold(2) == 0 ) then
!			Inc5threshold(2) = ii
!			wgtik(2) = 1.0d0 - (cummmk - 0.4d0)/(muinc(ii))
!		elseif (cummmk >= 0.6d0 .and. Inc5threshold(3) == 0 ) then
!			Inc5threshold(3) = ii
!			wgtik(3) = 1.0d0 - (cummmk - 0.6d0)/(muinc(ii))
!		elseif (cummmk >= 0.8d0 .and. Inc5threshold(4) == 0 ) then
!			Inc5threshold(4) = ii
!			wgtik(4) = 1.0d0 - (cummmk - 0.8d0)/(muinc(ii))
!		end if
!	end do
!
!	SumwgtInc5 = 0.0d0
!	TrsumInc5 = 0.0d0
!    IncsumInc5 = 0.0d0
!
!	do ii = 1,(nk*nx)
!		if (ii < Inc5threshold(1)) then
!			SumwgtInc5(1) = SumwgtInc5(1) + muinc(ii)
!			TrsumInc5(1) = TrsumInc5(1) + muinc(ii)*trgrid(ii)
!            IncsumInc5(1) = IncsumInc5(1) + muinc(ii)*incgrid(ii)
!		elseif (ii == Inc5threshold(1)) then
!			SumwgtInc5(1) = SumwgtInc5(1) + muinc(ii)*wgtik(1)
!			SumwgtInc5(2) = SumwgtInc5(2) + muinc(ii)*(1.0d0-wgtik(1))
!			TrsumInc5(1) = TrsumInc5(1) + muinc(ii)*trgrid(ii)*wgtik(1)
!			TrsumInc5(2) = TrsumInc5(2) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(1))
!            IncsumInc5(1) = IncsumInc5(1) + muinc(ii)*incgrid(ii)*wgtik(1)
!            IncsumInc5(2) = IncsumInc5(2) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(1))
!		elseif (ii > Inc5threshold(1) .and. ii < Inc5threshold(2)) then
!			SumwgtInc5(2) = SumwgtInc5(2) + muinc(ii)
!			TrsumInc5(2) = TrsumInc5(2) + muinc(ii)*trgrid(ii)
!            IncsumInc5(2) = IncsumInc5(2) + muinc(ii)*incgrid(ii)
!		elseif (ii == Inc5threshold(2)) then
!			SumwgtInc5(2) = SumwgtInc5(2) + muinc(ii)*wgtik(2)
!			SumwgtInc5(3) = SumwgtInc5(3) + muinc(ii)*(1.0d0-wgtik(2))
!			TrsumInc5(2) = TrsumInc5(2) + muinc(ii)*trgrid(ii)*wgtik(2)
!			TrsumInc5(3) = TrsumInc5(3) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(2))
!            IncsumInc5(2) = IncsumInc5(2) + muinc(ii)*incgrid(ii)*wgtik(2)
!            IncsumInc5(3) = IncsumInc5(3) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(2))
!		elseif (ii > Inc5threshold(2) .and. ii < Inc5threshold(3)) then
!			SumwgtInc5(3) = SumwgtInc5(3) + muinc(ii)
!			TrsumInc5(3) = TrsumInc5(3) + muinc(ii)*trgrid(ii)
!            IncsumInc5(3) = IncsumInc5(3) + muinc(ii)*incgrid(ii)
!		elseif (ii == Inc5threshold(3)) then
!			SumwgtInc5(3) = SumwgtInc5(3) + muinc(ii)*wgtik(3)
!			SumwgtInc5(4) = SumwgtInc5(4) + muinc(ii)*(1.0d0-wgtik(3))
!			TrsumInc5(3) = TrsumInc5(3) + muinc(ii)*trgrid(ii)*wgtik(3)
!			TrsumInc5(4) = TrsumInc5(4) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(3))
!            IncsumInc5(3) = IncsumInc5(3) + muinc(ii)*incgrid(ii)*wgtik(3)
!            IncsumInc5(4) = IncsumInc5(4) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(3))
!		elseif (ii > Inc5threshold(3) .and. ii < Inc5threshold(4)) then
!			SumwgtInc5(4) = SumwgtInc5(4) + muinc(ii)
!			TrsumInc5(4) = TrsumInc5(4) + muinc(ii)*trgrid(ii)
!            IncsumInc5(4) = IncsumInc5(4) + muinc(ii)*incgrid(ii)
!		elseif (ii == Inc5threshold(4)) then
!			SumwgtInc5(4) = SumwgtInc5(4) + muinc(ii)*wgtik(4)
!			SumwgtInc5(5) = SumwgtInc5(5) + muinc(ii)*(1.0d0-wgtik(4))
!			TrsumInc5(4) = TrsumInc5(4) + muinc(ii)*trgrid(ii)*wgtik(4)
!			TrsumInc5(5) = TrsumInc5(5) + muinc(ii)*trgrid(ii)*(1.0d0-wgtik(4))
!            IncsumInc5(4) = IncsumInc5(4) + muinc(ii)*incgrid(ii)*wgtik(4)
!            IncsumInc5(5) = IncsumInc5(5) + muinc(ii)*incgrid(ii)*(1.0d0-wgtik(4))
!		else
!			SumwgtInc5(5) = SumwgtInc5(5) + muinc(ii)
!			TrsumInc5(5) = TrsumInc5(5) + muinc(ii)*trgrid(ii)
!            IncsumInc5(5) = IncsumInc5(5) + muinc(ii)*incgrid(ii)
!		end if
!    end do
!
!    ! 20180718 progressive part only
!	TrInc51 = (TrsumInc5(1)/SumwgtInc5(1))/(Tragg-T0)
!	TrInc52 = (TrsumInc5(2)/SumwgtInc5(2))/(Tragg-T0)
!	TrInc53 = (TrsumInc5(3)/SumwgtInc5(3))/(Tragg-T0)
!	TrInc54 = (TrsumInc5(4)/SumwgtInc5(4))/(Tragg-T0)
!	TrInc55 = (TrsumInc5(5)/SumwgtInc5(5))/(Tragg-T0)
!
!    TrIncInc51 = (TrsumInc5(1)/IncsumInc5(1))
!	TrIncInc52 = (TrsumInc5(2)/IncsumInc5(2))
!	TrIncInc53 = (TrsumInc5(3)/IncsumInc5(3))
!	TrIncInc54 = (TrsumInc5(4)/IncsumInc5(4))
!	TrIncInc55 = (TrsumInc5(5)/IncsumInc5(5))
!
!end subroutine calcdiststat


subroutine calwagegini(xgrid,ndist,mumat,wage,HBAR,EPratio,wagegini)

    implicit none

    real(8), intent(in) :: xgrid(:), ndist(:,:), mumat(:,:), wage, HBAR, EPratio
    real(8), intent(out) :: wagegini

    real(8), allocatable :: stnrpdf(:), stnrcdf(:), tempvec1(:), tempvec2(:)
    real(8), allocatable :: dc(:), db(:), tempmat1(:,:), tempmat2(:,:)
    integer :: ix, nk, nx

    nk = size(mumat,1)
    nx = size(mumat,2)
    allocate(stnrpdf(nx), stnrcdf(nx), tempvec1(nx), tempvec2(nx))
    allocate(dc(nx-1), db(nx-1), tempmat1(nk,nx), tempmat2(nk,nx))

    ! Calculate binary work choice (1 or 0) on the pdf
    tempmat1 = ndist/HBAR;
    ! Compute the conditional pdf of workers
    tempmat2 = (tempmat1*mumat)/EPratio

    ! stnrpdf: integrating capital out
    ! call calcstnrpdf(tempmat2,idmat,stnrpdf,stnrcdf)
    stnrpdf = 0.0d0
    do ix = 1,nx
        stnrpdf(ix) = stnrpdf(ix) + sum(tempmat2(:,ix))
    end do

    ! Generate the Lorenz Curve (tempvec2)
    tempvec1 = wage*xgrid*stnrpdf

    do ix = 1,nx
    	tempvec2(ix) = sum(tempvec1(1:ix))/sum(tempvec1)
    end do

    call calcgini(tempvec2,stnrpdf,wagegini)


end subroutine calwagegini


subroutine calearnsgini(xgrid,ndist,mumat,wage,earnsgini)

    implicit none

    real(8), intent(in) :: xgrid(:), ndist(:,:), mumat(:,:), wage
    real(8), intent(out) :: earnsgini

    real(8), allocatable :: stnrpdf(:), stnrcdf(:), tempvec1(:), tempvec2(:)
    real(8), allocatable :: dc(:), db(:), tempmat1(:,:), tempmat2(:,:)
    integer :: ix, nk, nx

    nk = size(mumat,1)
    nx = size(mumat,2)
    allocate(stnrpdf(nx), stnrcdf(nx), tempvec1(nx), tempvec2(nx))
    allocate(dc(nx-1), db(nx-1), tempmat1(nk,nx), tempmat2(nk,nx))

    tempmat2 = mumat

    ! stnrpdf: integrating capital out
    ! call calcstnrpdf(tempmat2,idmat,stnrpdf,stnrcdf)
    stnrpdf = 0.0d0
    do ix = 1,nx
        stnrpdf(ix) = stnrpdf(ix) + sum(tempmat2(:,ix))
    end do

    ! Generate the Lorenz Curve (tempvec2)
    tempmat1 = wage*ndist*mumat

    do ix = 1,nx
        tempvec1(ix) = sum(tempmat1(:,ix))
    end do

    do ix = 1,nx
    	tempvec2(ix) = sum(tempvec1(1:ix))/sum(tempvec1)
    end do

    call calcgini(tempvec2,stnrpdf,earnsgini)


end subroutine calearnsgini


subroutine calwealthgini(kgrid,mumat,wealthgini)

    implicit none

    real(8), intent(in) :: kgrid(:), mumat(:,:)
    real(8), intent(out) :: wealthgini

    real(8), allocatable :: stnrpdf(:), stnrcdf(:), tempvec1(:), tempvec2(:)
    real(8), allocatable :: dc(:), db(:), tempmat1(:,:), tempmat2(:,:)
    integer :: ix, ik, nk, nx

    nk = size(mumat,1)
    nx = size(mumat,2)    
    allocate(stnrpdf(nk), stnrcdf(nk), tempvec1(nk), tempvec2(nk))
    allocate(dc(nk-1), db(nk-1), tempmat1(nx,nk), tempmat2(nx,nk))

    tempmat2 = transpose(mumat) ! nx x nk

    ! stnrpdf: integrating capital out
    stnrpdf = 0.0d0
    do ik = 1,nk
        stnrpdf(ik)=sum(tempmat2(:,ik))
    end do
    ! call calcstnrpdf(tempmat2,stnrpdf,stnrcdf)

    ! Generate the Lorenz Curve (tempvec2)
    tempvec1 = kgrid*stnrpdf
    ! aaa = sum(tempvec1)
    do ik = 1,nk
        tempvec2(ik) = sum(tempvec1(1:ik))/sum(tempvec1)
    end do

    call calcgini(tempvec2,stnrpdf,wealthgini)


end subroutine calwealthgini


subroutine calcgini(tempvec2,stnrpdf,gini)

    implicit none

    real(8), intent(in) :: tempvec2(:), stnrpdf(:)
    real(8), intent(out) :: gini
    integer ix, nx
    real(8), allocatable :: dc(:), db(:)
    real(8) aaa, bbb

    nx = size(tempvec2,1)
    allocate(dc(nx),db(nx))

    ! Calculate the gini coefficient of wage
    do ix = 1,nx-1
        dc(ix) = stnrpdf(ix+1) !stnrcdf(ix+1)-stnrcdf(ix)
        db(ix) = (tempvec2(ix+1)+tempvec2(ix))*0.5d0
    end do

    bbb = sum(dc*db)
    aaa = 0.5d0-bbb
    gini = 2.0d0*aaa


end subroutine calcgini


end module mod_calcss
