clear all;

% for HSV_HAT model
load ./HSV_HAT/ss_summary.txt;

B0 = ss_summary(2);
beta = ss_summary(3);
SDINOVX = ss_summary(5);
T0 = ss_summary(10);
Trscale = ss_summary(6);
Transprog1 = ss_summary(7);
EPratio = ss_summary(12);
r = ss_summary(15);
Giniwage = ss_summary(20);
TrY = ss_summary(23);
Tr2Y = ss_summary(24);
TrInc51 = ss_summary(26);

% Table 1
disp(' ');
disp(' Table 1');
disp(' Parameters:');
disp(sprintf('  Disutility of work = %1.3f',B0));
disp(sprintf('  Subject discount factor = %1.3f',beta));
disp(sprintf('  S.D. of inovations to lnx = %1.3f',SDINOVX));
disp(sprintf('  Overall transfer size = %1.4f',T0));
disp(sprintf('  Scale of non-flat transfers = %1.3f',Trscale));
disp(sprintf('  Progressivity of transfers = %1.2f',Transprog1));
disp(' ');
disp(' Target statistics:');
disp(sprintf('  Employment rate = %1.3f',EPratio));
disp(sprintf('  Real interest rate = %1.3f',r));
disp(sprintf('  Wage Gini index = %1.3f',Giniwage));
disp(sprintf('  Ratio of Avg(T1+T2)/Output = %1.3f',TrY));
disp(sprintf('  Ratio of Avg(T2)/Output = %1.4f',Tr2Y));
disp(sprintf('  E(T2|1st Inc)/E(T2) = %1.2f',TrInc51));

% Table 2
% for HSV_HAT model
load ./HSV_HAT/ss_summary.txt;
TrInc51 = ss_summary(26);
TrInc52 = ss_summary(27);
TrInc53 = ss_summary(28);
TrInc54 = ss_summary(29);
TrInc55 = ss_summary(30);
TrW51 = ss_summary(31);
TrW52 = ss_summary(32);
TrW53 = ss_summary(33);
TrW54 = ss_summary(34);
TrW55 = ss_summary(35);
EmpW51 = ss_summary(36);
EmpW52 = ss_summary(37);
EmpW53 = ss_summary(38);
EmpW54 = ss_summary(39);
EmpW55 = ss_summary(40);
ShareW51 = ss_summary(41);
ShareW52 = ss_summary(42);
ShareW53 = ss_summary(43);
ShareW54 = ss_summary(44);
ShareW55 = ss_summary(45);
TrIncEmp = ss_summary(end);
TrIncNoEmp = ss_summary(end-1);
temp1_HAT = round([ShareW51 ShareW52 ShareW53 ShareW54 ShareW55],1);
temp2_HAT = 100*round([EmpW51 EmpW52 EmpW53 EmpW54 EmpW55],3);
temp3_HAT = round([TrInc51 TrInc52 TrInc53 TrInc54 TrInc55 TrIncEmp TrIncNoEmp],2);

% for HSV_HAN model
load ./HSV_HAN/ss_summary.txt;
TrInc51 = ss_summary(26);
TrInc52 = ss_summary(27);
TrInc53 = ss_summary(28);
TrInc54 = ss_summary(29);
TrInc55 = ss_summary(30);
TrW51 = ss_summary(31);
TrW52 = ss_summary(32);
TrW53 = ss_summary(33);
TrW54 = ss_summary(34);
TrW55 = ss_summary(35);
EmpW51 = ss_summary(36);
EmpW52 = ss_summary(37);
EmpW53 = ss_summary(38);
EmpW54 = ss_summary(39);
EmpW55 = ss_summary(40);
ShareW51 = ss_summary(41);
ShareW52 = ss_summary(42);
ShareW53 = ss_summary(43);
ShareW54 = ss_summary(44);
ShareW55 = ss_summary(45);
temp1_HAN = round([ShareW51 ShareW52 ShareW53 ShareW54 ShareW55],1);
temp2_HAN = 100*round([EmpW51 EmpW52 EmpW53 EmpW54 EmpW55],3);

% for HSV_HAF model
load ./HSV_HAF/ss_summary.txt;
TrInc51 = ss_summary(26);
TrInc52 = ss_summary(27);
TrInc53 = ss_summary(28);
TrInc54 = ss_summary(29);
TrInc55 = ss_summary(30);
TrW51 = ss_summary(31);
TrW52 = ss_summary(32);
TrW53 = ss_summary(33);
TrW54 = ss_summary(34);
TrW55 = ss_summary(35);
EmpW51 = ss_summary(36);
EmpW52 = ss_summary(37);
EmpW53 = ss_summary(38);
EmpW54 = ss_summary(39);
EmpW55 = ss_summary(40);
ShareW51 = ss_summary(41);
ShareW52 = ss_summary(42);
ShareW53 = ss_summary(43);
ShareW54 = ss_summary(44);
ShareW55 = ss_summary(45);
temp1_HAF = round([ShareW51 ShareW52 ShareW53 ShareW54 ShareW55],1);
temp2_HAF = 100*round([EmpW51 EmpW52 EmpW53 EmpW54 EmpW55],3);


disp(' ');
disp(' Table 2: Characteristics of wealth distribution')
disp(' Share of wealth (%)');
disp(sprintf('  HA-T:  %2.1f, %2.1f, %2.1f, %2.1f, %2.1f',temp1_HAT));
disp(sprintf('  HA-N:  %2.1f, %2.1f, %2.1f, %2.1f, %2.1f',temp1_HAN));
disp(sprintf('  HA-F:  %2.1f, %2.1f, %2.1f, %2.1f, %2.1f',temp1_HAF));
disp(' Employment rate (%)');
disp(sprintf('  HA-T:  %2.1f, %2.1f, %2.1f, %2.1f, %2.1f',temp2_HAT));
disp(sprintf('  HA-N:  %2.1f, %2.1f, %2.1f, %2.1f, %2.1f',temp2_HAN));
disp(sprintf('  HA-F:  %2.1f, %2.1f, %2.1f, %2.1f, %2.1f',temp2_HAF));

% Table 3
disp(' ');
disp(' Table 3: Progressivity of income-security transfers')
disp(sprintf('  HA-T:  %1.2f, %1.2f, %1.2f, %1.2f, %1.2f, %1.2f, %1.2f',temp3_HAT));
