clear all;
DELTA = 0.025;

% for HSV_HAT model
load ./HSV_HAT/ss_summary.txt;

EPratio = ss_summary(12);
TrInc51 = ss_summary(26);
TrInc52 = ss_summary(27);
TrInc53 = ss_summary(28);
TrInc54 = ss_summary(29);
TrInc55 = ss_summary(30);
EmpW51 = ss_summary(36);
EmpW52 = ss_summary(37);
EmpW53 = ss_summary(38);
EmpW54 = ss_summary(39);
EmpW55 = ss_summary(40);

temp1_HAT = 100*round([EPratio EmpW51 EmpW52 EmpW53 EmpW54 EmpW55],3);
temp2_HAT = round([TrInc51 TrInc52 TrInc53 TrInc54 TrInc55],2);

dir = './HSV_HAT/';
yvec = importdata(strcat(dir,'yvec.txt'));
cvec = importdata(strcat(dir,'cvec.txt'));
xvec = importdata(strcat(dir,'xvec.txt'));
lvec = importdata(strcat(dir,'lvec.txt'));
hvec = importdata(strcat(dir,'hvec.txt'));
zvec = importdata(strcat(dir,'zvec.txt'));
wvec = importdata(strcat(dir,'wvec.txt'));
rvec = importdata(strcat(dir,'rvec.txt'));

T = length(yvec);
yhvec = yvec./hvec;
rvec = rvec + DELTA;

so = log([yvec cvec xvec lvec hvec yhvec wvec]);
sd = hpfilter(so,1600);
sd = sd(9:T-8,:);
T0 = T-16;

std0 = std(sd);
corr0 = corr(sd);
temp3_HAT = round([std0(1)*100 std0(5)/std0(1) corr0(1,6) corr0(5,6)],2);

% for HSV_HAT_ProgTax model
load ./HSV_HAT_ProgTax/ss_summary.txt;

EPratio = ss_summary(12);
TrInc51 = ss_summary(26);
TrInc52 = ss_summary(27);
TrInc53 = ss_summary(28);
TrInc54 = ss_summary(29);
TrInc55 = ss_summary(30);
EmpW51 = ss_summary(36);
EmpW52 = ss_summary(37);
EmpW53 = ss_summary(38);
EmpW54 = ss_summary(39);
EmpW55 = ss_summary(40);

temp1_HAT_ProgTax = 100*round([EPratio EmpW51 EmpW52 EmpW53 EmpW54 EmpW55],3);
temp2_HAT_ProgTax = round([TrInc51 TrInc52 TrInc53 TrInc54 TrInc55],2);

dir = './HSV_HAT_ProgTax/';
yvec = importdata(strcat(dir,'yvec.txt'));
cvec = importdata(strcat(dir,'cvec.txt'));
xvec = importdata(strcat(dir,'xvec.txt'));
lvec = importdata(strcat(dir,'lvec.txt'));
hvec = importdata(strcat(dir,'hvec.txt'));
zvec = importdata(strcat(dir,'zvec.txt'));
wvec = importdata(strcat(dir,'wvec.txt'));
rvec = importdata(strcat(dir,'rvec.txt'));

T = length(yvec);
yhvec = yvec./hvec;
rvec = rvec + DELTA;

so = log([yvec cvec xvec lvec hvec yhvec wvec]);
sd = hpfilter(so,1600);
sd = sd(9:T-8,:);
T0 = T-16;

std0 = std(sd);
corr0 = corr(sd);
temp3_HAT_ProgTax = round([std0(1)*100 std0(5)/std0(1) corr0(1,6) corr0(5,6)],2);

% for HSV_HAT_ProgTransfer model
load ./HSV_HAT_ProgTransfer/ss_summary.txt;

EPratio = ss_summary(12);
TrInc51 = ss_summary(26);
TrInc52 = ss_summary(27);
TrInc53 = ss_summary(28);
TrInc54 = ss_summary(29);
TrInc55 = ss_summary(30);
EmpW51 = ss_summary(36);
EmpW52 = ss_summary(37);
EmpW53 = ss_summary(38);
EmpW54 = ss_summary(39);
EmpW55 = ss_summary(40);

temp1_HAT_ProgTransfer = 100*round([EPratio EmpW51 EmpW52 EmpW53 EmpW54 EmpW55],3);
temp2_HAT_ProgTransfer = round([TrInc51 TrInc52 TrInc53 TrInc54 TrInc55],2);

dir = './HSV_HAT_ProgTransfer/';
yvec = importdata(strcat(dir,'yvec.txt'));
cvec = importdata(strcat(dir,'cvec.txt'));
xvec = importdata(strcat(dir,'xvec.txt'));
lvec = importdata(strcat(dir,'lvec.txt'));
hvec = importdata(strcat(dir,'hvec.txt'));
zvec = importdata(strcat(dir,'zvec.txt'));
wvec = importdata(strcat(dir,'wvec.txt'));
rvec = importdata(strcat(dir,'rvec.txt'));

T = length(yvec);
yhvec = yvec./hvec;
rvec = rvec + DELTA;

so = log([yvec cvec xvec lvec hvec yhvec wvec]);
sd = hpfilter(so,1600);
sd = sd(9:T-8,:);
T0 = T-16;

std0 = std(sd);
corr0 = corr(sd);
temp3_HAT_ProgTransfer = round([std0(1)*100 std0(5)/std0(1) corr0(1,6) corr0(5,6)],2);

disp(' ');
disp(' Table 6')
disp(' Steady state');
disp('  Employment rate');
disp([temp1_HAT(1) temp1_HAT_ProgTransfer(1) temp1_HAT_ProgTax(1)]);
disp('  Wealth quintile');
disp([temp1_HAT(2:end)' temp1_HAT_ProgTransfer(2:end)' temp1_HAT_ProgTax(2:end)']);
disp('  T2 ratio by income quintile');
disp([temp2_HAT' temp2_HAT_ProgTransfer' temp2_HAT_ProgTax']);
disp(' Business cycles');
disp([temp3_HAT' temp3_HAT_ProgTransfer' temp3_HAT_ProgTax']);

% disp([[temp1_HAT';temp2_HAT';temp3_HAT'],[temp1_HAT_ProgTransfer';temp2_HAT_ProgTransfer';temp3_HAT_ProgTransfer'],[temp1_HAT_ProgTax';temp2_HAT_ProgTax';temp3_HAT_ProgTax']]);
